;--------------------------------------
; Bible Search Utility using the ASV translation

       .386
       .model  flat, stdcall           ; 32 bit memory model
       option  casemap :none           ; case sensitive

;      Include Files
;      --------------------------------
       include \masm32\include\windows.inc
       include \masm32\include\masm32.inc
       include \masm32\include\gdi32.inc
       include \masm32\include\user32.inc
       include \masm32\include\kernel32.inc
       include \masm32\include\Comctl32.inc
       include \masm32\include\comdlg32.inc
       include \masm32\include\shell32.inc
       include \masm32\include\shlwapi.inc
       include \masm32\include\oleaut32.inc
       include \masm32\include\advapi32.inc

;      Libraries
;      --------------------------------
       includelib  \masm32\lib\masm32.lib
       includelib  \masm32\lib\gdi32.lib
       includelib  \masm32\lib\user32.lib
       includelib  \masm32\lib\kernel32.lib
       includelib  \masm32\lib\Comctl32.lib
       includelib  \masm32\lib\comdlg32.lib
       includelib  \masm32\lib\shell32.lib
       includelib  \masm32\lib\shlwapi.lib
       includelib  \masm32\lib\oleaut32.lib
       includelib  \masm32\lib\advapi32.lib

; Local Prototypes
;--------------------------------------
AddLineItem    PROTO
AddSeparator   PROTO
AppendToMenu   PROTO
Confirmation   PROTO   :DWORD
CreateWin      PROTO   :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
Do_Status      PROTO   :DWORD
Do_ToolBar     PROTO   :DWORD
DoPageSU       PROTO
EditControl    PROTO   :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
EnableDisable  PROTO
FillBuffer     PROTO   :DWORD,:DWORD,:BYTE
Find           PROTO   :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
FindReplace    PROTO   :DWORD, :DWORD, :DWORD, :DWORD
Font           PROTO
GetFileName    PROTO   :DWORD,:DWORD,:DWORD
GetRegKeyDW    PROTO   :DWORD,:DWORD,:DWORD
GetRegKeysz    PROTO   :DWORD,:DWORD,:DWORD,:DWORD
GtFrmRegistry  PROTO
hEditProc      PROTO   :DWORD,:DWORD,:DWORD,:DWORD
LoadMRUFiles   PROTO
SpecialProc    PROTO   :DWORD, :DWORD, :DWORD, :DWORD
MergeFile      PROTO   :DWORD
ofCallBack     PROTO   :DWORD,:DWORD,:DWORD,:DWORD
Paint_Proc     PROTO   :DWORD,:DWORD
PrintProc      PROTO
QFour          PROTO
SaveFileName   PROTO   :DWORD,:DWORD,:DWORD
SaveMRUFiles   PROTO
Select_All     PROTO   :DWORD
SetBGColor     PROTO
SetBmpColor    PROTO   :DWORD
SetRegKeyDW    PROTO   :DWORD,:DWORD,:DWORD
SetRegKeysz    PROTO   :DWORD,:DWORD,:DWORD,:DWORD
ShowPosition   PROTO
StreamFileIn   PROTO   :DWORD,:DWORD
TopXY          PROTO   :DWORD,:DWORD
WinMain        PROTO   :DWORD,:DWORD,:DWORD,:DWORD
WndProc        PROTO   :DWORD,:DWORD,:DWORD,:DWORD
WordWrap       PROTO

wsprintfA      PROTO   C :DWORD,:VARARG
wsprintf       equ     <wsprintfA>

;      Local Macros
;      --------------------------------
szText MACRO   Name, Text:VARARG
       LOCAL   lbl
       jmp     lbl
       Name    db      Text,0
   lbl:
       ENDM

m2m    MACRO   M1, M2
       push    M2
       pop     M1
       ENDM

MOVmw  MACRO   Var1, Var2
       pushad 
       lea     esi, Var2
       lea     edi, Var1
       REPEAT     2
         mov     al, [esi]
         mov     [edi], al
         inc     esi
         inc     edi
       ENDM
       popad
       ENDM

return MACRO   arg
       mov     eax, arg
       ret
       ENDM

stralloc   MACRO   ln
       invoke  SysAllocStringByteLen,0, ln
       ENDM

strfree MACRO  strhandle
       invoke  SysFreeString, strhandle
       ENDM

;      --------------------------------
;      Macros for creating the Toolbar
;      --------------------------------

TBextraData MACRO
       mov     tbb.fsState, TBSTATE_ENABLED
       mov     tbb.dwData,  0
       mov     tbb.iString, 0
       ENDM

;      --------------------------------

TBbutton MACRO bID,  cID
       LOCAL   SeeYa
       LOCAL   Normal

       mov     tbb.iBitmap, bID        ; button  ID number
       mov     tbb.idCommand, cID      ; command ID number
       cmp     tbb.idCommand, 66       ; WordWrap Button?
       jne     Normal
       mov     tbb.fsStyle, TBSTYLE_CHECK
       jmp     SeeYa
Normal:
       mov     tbb.fsStyle, TBSTYLE_BUTTON
SeeYa:
       invoke  SendMessage, hToolBar, TB_ADDBUTTONS, 1, ADDR tbb
       ENDM

;      --------------------------------

TBblank MACRO
       mov     tbb.iBitmap, 0
       mov     tbb.idCommand, 0
       mov     tbb.fsStyle, TBSTYLE_SEP
       invoke  SendMessage, hToolBar, TB_ADDBUTTONS, 1, ADDR tbb
       ENDM

;      --------------------------------

Create_Tool_Bar MACRO Wd, Ht
       szText  tbClass, "ToolbarWindow32"
       invoke  CreateWindowEx, 0, ADDR tbClass, ADDR szDisplayName,
               WS_CHILD or WS_VISIBLE or TBSTYLE_TOOLTIPS,
               0, 0, 500, 40, hWin, NULL, hInstance, NULL
       mov     hToolBar, eax
       invoke  SendMessage, hToolBar, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
       invoke  SendMessage, hToolBar, TB_GETTOOLTIPS, 0, 0
       mov     hToolTips, eax
       invoke  SendMessage, hToolTips, TTM_SETDELAYTIME, TTDT_INITIAL, 0
       invoke  SendMessage, hToolTips, TTM_SETDELAYTIME, TTDT_RESHOW, 0
;      --------------------------------
;      Put width & height of bitmap into DWORD
;      --------------------------------
       mov     ecx, Wd                 ; loword = bitmap Width
       mov     eax, Ht                 ; hiword = bitmap Height
       shl     eax, 16
       mov     ax, cx
       mov     bSize, eax
       invoke  SendMessage, hToolBar, TB_SETBITMAPSIZE, 0, bSize
       invoke  SetBmpColor, hTbBmp
       mov     hTbBmp,eax
       mov     tbab.hInst, 0
       m2m     tbab.nID, hTbBmp
       invoke  SendMessage, hToolBar, TB_ADDBITMAP, 12, ADDR tbab
       invoke  SendMessage, hToolBar, TB_SETBUTTONSIZE, 0, bSize
       ENDM

; Equates
ERROR_NO_SELECTION equ 30012
;--------------------------------------
; Select right click menu popup here
menu_popup     equ 0                   ; 0 = File, 1 = Edit etc ....
IDM_WWRAP      equ 1111
ID_EDITWINDOW  equ 5003

; Tasc Help System
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
IDC_ASSEMBLER  equ 2001                ; Assembler Button
IDC_JCOMPILER  equ 2002                ; Java Compiler Button
IDC_GENERAL    equ 2003                ; General Information Button
IDC_REPORT     equ 2004                ; Error Reporting Button
IDC_NOTES      equ 2005                ; Notes Button
IDC_ABOUT      equ 2006                ; About Button
IDC_INFORM     equ 2007                ; Display Window


.data
EditMl         db  'RichEdit20a', 0
ReDLL          db  'RICHED20.DLL', 0
OA             dd  0
bytesread      dd  0
dwAttr         dd  0
hFile          dd  0
sw1            dd  0
szTitleO       db  'Open A File', 0
szTitleS       db  'Save file as', 0
szTitleM       db  'Merge File', 0
szFilter       db  'All files', 0, '*.*', 0,
                   'Text files', 0, '*.TXT', 0, 0
confirm        db  'File is not saved, Save it now?', 0
cantfind       db  'Sorry, cannot find that file.', 0
Sorry          db  'Window could not be created.', 0
SorryCrErr     db  'The File could not be created!', 0
SorryOpErr     db  'The File could not be opened!', 0
szSaving       db  'File modified:  Save the Changes?', 0
hTbBmp         dd  0
hToolBar       dd  0
hStatus        dd  0
szFileName     db  260 dup(0)
szDisplayName  db  'MASM32 Richedit', 0
pTitle         db  'Bible Search Utility, Version 1.0.0 - ', 0
Untitled       db  'Untitled', 0
fSizeBuffer    db  8 dup(0)
OpenMsg        db  ' Opened at ', 0
OpenByt        db  ' bytes', 0
ShowfSize      db  ' New File', 24 dup(0)
fSize          dd  0
FirstTime      db  1
Minute         dd  0
Counter        db  0

; Menu Stuff
MRUDump        db  256 dup(0)
               db  256 dup(0)
               db  256 dup(0)
               db  256 dup(0)
               db  256 dup(0)
EndOfDump      db  0
szMenuEntry    db  256 dup(0)
hMenu          dd  0
hSubMenu       dd  0
itemcount      dd  0
Block          dd  0
isModified     dd  0
amtAdded       dd  0
Partial        dd  0
MenuID         dd  0

; Tasc Help System
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
szButton1      db  'If you are interested in Assembly Language Programming for '
               db  'Windows (or Win32, as it is really called), search for MASM32 '
               db  'on the web to find Hutch',27h,'s SDK for Windows Assembly. It is '
               db  'the best, in my opinion. Once installed, you can use this editor '
               db  'to begin coding programs.',13,10,13,10
               db  'Under the ',27h,'Tools',27h,' menu you will find '
               db  'two options, one is ',27h,'Assemble from BAT',27h,' and the other is ',27h,'Run '
               db  'JAVA Compiler',27h,'. Examine the source code that came with this '
               db  'Editor. Make a Batch file and a Make file in the same manner. '
               db  'The BAT and RC files MUST have the same name as the ASM '
               db  'file. Example:  MyIdea.asm needs MyIdea.bat and MyIdea.rc '
               db  'in order for the option to work. If you are working on an ASM '
               db  'or RC file the Editor will build the appropriate BAT file name and '
               db  'enable the ',27h,'Assemble From BAT',27h,' menu selection.', 0
szButton2      db  'In order to set up this editor to seamlessly integrate with the '
               db  'Java Compiler, the Java SDK must be downloaded from the '
               db  'Web (Internet) and installed on the machine. Then use this '
               db  'editor to write some java code.',13,10,13,10
               db  'Save it in a .java file. When the Editor detects a .java file it enables '
               db  'the ',27h,'Run Java Compiler',27h,' option. When that option is clicked, '
               db  'javac.exe will run with the following options, ',27h,'-g:none -verbose'
               db  27h,', this means that no debugging information will be saved. A '
               db  'modification that I will do in the near future will allow the user '
               db  'to customize all settings as needed. Be sure to add the Java BIN '
               db  'directory to your path statement in the ',27h,'autoexec.bat',27h,' file.', 0
szButton3      db  'At first glance, it might appear that this is just another editor. '
               db  'The reality is that it IS an editor but what makes it useful to a '
               db  'programmer is the options that have been included with it. '
               db  'Options included are linking to a WIN32 Assembler and also to '
               db  'a Java Compiler. It is possible that more will appear as time '
               db  'goes on.',13,10,13,10
               db  'Assembly Language and Java Applet Programming (designing specialty '
               db  'applets for the web) are two types of programming that I am '
               db  'very interested in so they have been included already.',13,10,13,10
               db  'Even though the editor has been completed, there will still be '
               db  'some minor changes to its functionality, but in the near future, '
               db  'a significant addition to this utility will be two Code Librarians. '
               db  'One for Assembly and one for Java. I am not entirely sure how '
               db  'or what they will do as of yet, so I will probably put the two '
               db  'libraries together and then work on the implimentation. This will '
               db  'make this utility more and more like an IDE. At some point, I am '
               db  'going to work on the development of a GUI type Resource '
               db  'Editor. Watch my webpage, the changes will occur in a fairly '
               db  'rapid manner because some of the code has already been '
               db  'developed.', 0
szButton4      db  'Do to the fact that I am trying to get this project up and running '
               db  'so quickly, sometimes troubleshooting will suffer. You can help me by '
               db  'reporting any errors that you find. Even though this Editor started '
               db  'out as Steve Hutchesson',27h,'s project, I have made so many changes '
               db  'that could have an impact on the original programming that it would '
               db  'not be fair to him if I were to direct your error reporting to him. '
               db  'If you encounter an error, please send email to me at the address '
               db  'listed at the bottom (and top) of this help box and it will be dealt '
               db  'with promptly.  Enjoy and thank you for your help.',13,10,13,10,13,10
               db  'pbrennick@cyburban.com',13,10
               db  'hutch@pbq.com.au', 0
szButton5      db  'Wish List:',13,10
               db  '~~~~~~~~~~~~',13,10
               db  'As this program is developed, more and more ideas occur to me or are suggested to me by those '
               db  'people who are beta testing it. A lot of the suggestions come from people who seem to be '
               db  'trying to turn this project into a wordprocessor.  This is not my intention nor will it ever '
               db  'become one. Please keep the ideas coming, though, I need that sort of help and in the near '
               db  'future, I will write a word processor.  All ideas have been saved and those that do not appear '
               db  'in this project will undoubtably appear in the next.',13,10,13,10
               db  13,10,'Paul E. Brennick', 0
szButton6      db  'Change Logs:',13,10
               db  '~~~~~~~~~~~~',13,10
               db  '08-07-2001:  Problem Resolved. When calling Font after WordWrap, the dialog box would not be '
               db  'displayed because WordWrap would leave the Font procedure running in silent mode.',13,10,13,10
               db  '08-05-2001:  Reworked Function. All the help type messages have been incorporated into a single '
               db  'Tasc Help System.  This Dialog based messaging system is also available as a stand-alone '
               db  'application that showes how to use a dialog box as the main window in a program. It also '
               db  'shows how to develop dialog boxes.',13,10,13,10
               db  '08-03-2001:  Problem Resolved. Duplicates were showing up in the list.  Also, rewrote the '
               db  'AppendToMenu procedure so that on very first run, empty selections were supressed.',13,10,13,10
               db  13,10,'Paul E. Brennick', 0

; Printer
szSelect       db  'Selected Text!  Print entire document anyway?', 0, 0
mL             dd  0
mT             dd  0
mR             dd  0
mB             dd  0
w1             dd  0
Len            dd  0
RTwips1000     REAL10  1.44
xPerInch       dd  0
yPerInch       dd  0
Sel            dd  0

; Font Stuff
hFont          dd  0
tempword       dd  0
bgColor        dd  0
BGCFlag        dd  0
PageSUFlag     dd  0
FontName       db  64 dup(0)
DecValue       db  10
Delimit        db  ', ', 0
EndOfString    db  ' Pt.', 0
ASCIIPointSize db  4 dup(0), 0
; Next 2 lines should never be separated
ShowFontName   db  ' '
defFontName    db  'Courier New', 54 dup(0)
defPointSize   dd  110                 ; Default Point Size * 10

; Registry Stuff
szKeyName      db  'Software\BibleSearch\', 0
szFontMessage  db  'Character Font', 0
szFontName     db  64 dup(0), 0
FNBufferLength DWORD SIZEOF szFontName + 1
szBGCMessage   db  'Background Color',0
szPointMessage db  'Twips', 0
szTwipsMessage db  'Point Size Times 10', 0
szPointSize    dd  0
szTwipsSize    dd  0
szWWrap        dd  1

; MRU Registry Stuff
szMRU_File1    db  256 dup(0)
szMRU_File2    db  256 dup(0)
szMRU_File3    db  256 dup(0)
szMRU_File4    db  256 dup(0)
szMRU_File5    db  256 dup(0)
MRUBufLen1     DWORD SIZEOF szMRU_File1 + 1
MRUBufLen2     DWORD SIZEOF szMRU_File2 + 1
MRUBufLen3     DWORD SIZEOF szMRU_File3 + 1
MRUBufLen4     DWORD SIZEOF szMRU_File4 + 1
MRUBufLen5     DWORD SIZEOF szMRU_File5 + 1
szMRUMessage1  db  'MRU_File1',0
szMRUMessage2  db  'MRU_File2',0
szMRUMessage3  db  'MRU_File3',0
szMRUMessage4  db  'MRU_File4',0
szMRUMessage5  db  'MRU_File5',0

; ------------------------------------
; string data for status bar messages
; used in WM_NOTIFY message.
; ------------------------------------
tbn_new        db  ' New File', 0
tbn_open       db  ' Open File', 0
tbn_save       db  ' Save File', 0
tbn_print      db  ' Print File', 0
tbn_cut        db  ' Edit Cut', 0
tbn_copy       db  ' Edit Copy', 0
tbn_paste      db  ' Edit Paste', 0
tbn_delete     db  ' Delete!', 0
tbn_undo       db  ' Edit Undo', 0
tbn_redo       db  ' Edit Redo', 0
tbn_find       db  ' Find Text', 0
tbn_replace    db  ' Replace Text', 0
tbn_wwrap      db  ' WordWrap', 0
tbn_quit       db  ' Close Editor', 0
tbn_else       db  '             ', 0
strOpen        db  'open', 0           ; Mode = 'Open'
SearchText     db  128 dup(0), 0

SpecialDLGName db  'SpecialDLG', 0     ; Special Help/Information Dialog Box

; Row/Column Display Variables
BinRow         dd  0
BinRowTotal    dd  0
BinColumn      dd  0
BinColumnTotal dd  0
BinColOffset   dd  0
FileOff        dd  0
szJavaFile     db  ' Java Source File', 0
szDocument     db  ' Document File', 0
TypeOfFile     db  ' Unspecified File Type', 0
emailAddress   db  ' paul@altavista.com', 0
ShowRow        db  24 dup(0)
ShowColumn     db  24 dup(0)
RowMsg         db  ' Row:  ',0
OfMsg          db  ' of ', 0
Row            db  6 dup(0)
RowTotal       db  6 dup(0)
ColumnMsg      db  ' Col:  ', 0
Column         db  5 dup(0)
ColumnTotal    db  5 dup(0)
Scratch        db  0

; Find and Replace stuff
szFind         db  128 dup(?)      ; Buffer for string to 'Find'
szFindNext     db  128 dup(?)      ; Buffer for comparison
szRep          db  128 dup(?)      ; Buffer for string to 'Replace'
szFR           db  'Find And Replace', 0

FindEnd        db  'There Are No More Matches.'
               db  0Dh,0Ah
               db  'Would You Like To Restart From The'
TopBot         db  ' Top? '
               db  0
Top            db  ' Top? '
Bot            db  ' Bot? '

; Structure
; ~~~~~~~~~
ofn    OPENFILENAME    <>
fr     FORMATRANGE     <0>             ; For EM_FORMATRANGE
ft     FINDTEXTEX      <>              ; Used by both Find and Replace
cr     CHARRANGE       <?>             ; Character range
pd     PRINTDLG        <?>             ; Print
doci   DOCINFO         <?>             ; Docinfo (printing support)
EditS  EDITSTREAM      <?>             ; For EM_STREAMIN/EM_STREAMOUT
rect   RECT            <?>             ; Rectangle
psd    PAGESETUPDLG    <?>             ; Page setup common dialog structure
charF  CHARFORMAT2     <?>             ; For EM_GETCHARFORMAT/EM_SETCHARFORMAT
cc     CHOOSECOLOR     <?>             ; Choose Color
cf     CHOOSEFONT      <?>             ; Keep CHOOSEFONT/LOGFONT together
lf     LOGFONT         <?>             ; For CreateFontIndirect
sTime  SYSTEMTIME      <?>             ; For Current Date and Time

.data?
CommandLine    dd  ?
hWnd           dd  ?
hInstance      dd  ?
hIcon          dd  ?
hRichEd        dd  ?
lpfnhEditProc  dd  ?
hToolTips      dd  ?
hCheck1        dd  ?
hCheck2        dd  ?
hCheck3        dd  ?
hCheck4        dd  ?
TextLen        dd  ?
CaseFlag       dd  ?
WholeWord      dd  ?
CtrlFlag       dd  ?
hMnu           dd  ?
CustClrs       dd  16 dup(?)

; Find and Replace stuff
FRFlags        dd  ?
hFRDlg         dd  ?                   ; Dialog box for Find or Replace
Prev           dd  ?


.code

program:
;      --------------------------------;
;      The entire program starts and   ;
;      ends in this block of code.     ;
;      --------------------------------;
       invoke  GetModuleHandle, NULL   ;
       mov     hInstance, eax          ;
       invoke  GetCommandLine          ;
       mov     CommandLine, eax        ;
       invoke  InitCommonControls      ;
       mov     CaseFlag, 1             ;
       mov     WholeWord, 0            ;
       mov     CtrlFlag, 0             ;
       invoke  WinMain, hInstance,     ;
               NULL, CommandLine,      ;
               SW_SHOWDEFAULT          ;
       invoke  ExitProcess, eax        ;
;      --------------------------------;

WinMain  proc  hInst    :DWORD,
               hPrevInst:DWORD,
               CmdLine  :DWORD,
               CmdShow  :DWORD
;--------------------------------------
       LOCAL   Wwd  :DWORD
       LOCAL   Wht  :DWORD
       LOCAL   Wtx  :DWORD
       LOCAL   Wty  :DWORD
       LOCAL   lpArg:DWORD
       LOCAL   sWid :DWORD
       LOCAL   sHgt :DWORD
       LOCAL   wc   :WNDCLASSEX
       LOCAL   msg  :MSG

;      Fill WNDCLASSEX structure with required variables
;      --------------------------------;
       invoke  LoadIcon, hInst, 500    ; icon ID
       mov     hIcon, eax              ;
       szText  szClassName, "Rich_Edit_Class"
       mov     wc.cbSize,        sizeof WNDCLASSEX
       mov     wc.style,         CS_BYTEALIGNWINDOW
       mov     wc.lpfnWndProc,   offset WndProc
       mov     wc.cbClsExtra,    NULL
       mov     wc.cbWndExtra,    NULL
       m2m     wc.hInstance,     hInst
       mov     wc.hbrBackground, NULL
       m2m     wc.lpszMenuName,  NULL
       mov     wc.lpszClassName, offset szClassName
       m2m     wc.hIcon,         hIcon
       invoke  LoadCursor,       NULL,IDC_ARROW
       mov     wc.hCursor,       eax
       m2m     wc.hIconSm,       hIcon
       invoke  RegisterClassEx,  ADDR wc

;      Size & center window at 75% of screen
;      size width and 550 pixels high
;      --------------------------------------
       invoke  GetSystemMetrics, SM_CXSCREEN
       mov     sWid, eax
       push    sWid
       shr     eax, 2
       sub     sWid, eax
       m2m     Wwd, sWid
       mov     eax, 550
       mov     sHgt, eax
       push    sHgt
       shr     eax, 2
       sub     sHgt, eax
       m2m     Wht, sHgt
       pop     sHgt
       invoke  TopXY, Wht, sHgt
       mov     Wty, eax
       pop     sWid
       invoke  TopXY, Wwd, sWid
       mov     Wtx, eax
       invoke  CreateWindowEx, WS_EX_LEFT or WS_EX_ACCEPTFILES,
               ADDR szClassName, ADDR Untitled, WS_OVERLAPPEDWINDOW,
               Wtx, Wty, Wwd, Wht, NULL, NULL, hInst, NULL
       mov     hWnd, eax

;      Get any command line filename
;      --------------------------------
       invoke  PathGetArgs, CommandLine
       mov     lpArg, eax
       mov     esi, eax
       lodsb
       cmp     al, 0
       je      noArgs                  ; jump if no arg
       cmp     al, 34
       jne     @F                      ; jump if no quote
       invoke  PathUnquoteSpaces, lpArg
       mov     lpArg, eax
@@:    invoke  exist, lpArg
       .if eax == 1
         invoke  lstrcpy, offset szFileName, lpArg
         invoke  StreamFileIn, hRichEd, lpArg
         invoke  SetWindowText, hWnd, lpArg
         invoke  SendMessage, hRichEd, EM_SETMODIFY, FALSE, 0
       .else
         invoke  MessageBox, hWnd, lpArg, ADDR cantfind, MB_OK
       .endif
noArgs:
       invoke  LoadMenu, hInst, 600    ; Menu ID
       mov     hMnu, eax               ; Save the handle
       invoke  SetMenu, hWnd, eax      ; Add the Menu to the window
       invoke  GtFrmRegistry           ; Get MRU and font defaults
       invoke  SetBGColor              ; Set the background color
       invoke  AppendToMenu            ; Insert the MRU list into the Menu
       invoke  ShowWindow, hWnd, SW_SHOWNORMAL
       invoke  UpdateWindow, hWnd      ; Display the editor

;      Loop until PostQuitMessage is sent
;      --------------------------------
StartLoop:
       invoke  QFour                   ; Update the Status Bar Banner
       invoke  EnableDisable           ; Various buttons and menuitems
       invoke  GetMessage, ADDR msg, NULL, 0, 0
       cmp     eax, 0                  ; Exit request?
       je      ExitLoop                ; Split, if it is
       invoke  IsDialogMessage, hFRDlg, ADDR msg
       cmp     eax, 0                  ; Was used by dialog box?
       jne     StartLoop               ; Jump to scan loop if yes

;      Process keystrokes directly in the message loop
;      --------------------------------
       .if msg.message == WM_KEYDOWN   ; Was a key pressed?
         .if msg.wParam == VK_ESCAPE   ; Escape key?
           invoke  SendMessage, hWnd, WM_SYSCOMMAND, SC_CLOSE, NULL
         .elseif msg.wParam == VK_CONTROL
           mov     CtrlFlag, 1         ; Control key, flag set
         .endif
       .endif
       .if msg.message == WM_KEYUP
         .if msg.wParam == VK_CONTROL
           mov     CtrlFlag, 0         ; Control key, flag clear
         .elseif msg.wParam == 4Eh     ; Ctrl + N
           .if CtrlFlag == 1
             invoke  SendMessage, hWnd, WM_COMMAND, 1000, 0
           .endif
         .elseif msg.wParam == 52h     ; Ctrl + R
           .if CtrlFlag == 1
             invoke  SendMessage, hWnd, WM_COMMAND, 1001, 0
           .endif
         .elseif msg.wParam == 57h     ; Ctrl + W
           .if CtrlFlag == 1
             invoke  SendMessage, hWnd, WM_COMMAND, 1111, 0
           .endif
         .elseif msg.wParam == 4Fh     ; Ctrl + O
           .if CtrlFlag == 1
             invoke  SendMessage, hWnd, WM_COMMAND, 1002, 0
           .endif
         .elseif msg.wParam == 53h     ; Ctrl + S
           .if CtrlFlag == 1
             invoke  SendMessage, hWnd, WM_COMMAND, 1003, 0
           .endif
         .elseif msg.wParam == 42h     ; Ctrl + B
           .if CtrlFlag == 1
             invoke  SendMessage, hWnd, WM_COMMAND, 1004, 0
           .endif
         .endif
       .endif
       invoke  ShowPosition
       invoke  TranslateMessage, ADDR msg
       invoke  DispatchMessage,  ADDR msg
       jmp     StartLoop
ExitLoop:
       return  msg.wParam
;--------------------------------------
WinMain  endp


WndProc  proc  hWin  :DWORD,
               uMsg  :DWORD,
               wParam:DWORD,
               lParam:DWORD
;--------------------------------------
       LOCAL   var  :DWORD
       LOCAL   caW  :DWORD
       LOCAL   caH  :DWORD
       LOCAL   hTbar:DWORD
       LOCAL   hSbar:DWORD
       LOCAL   tl   :DWORD
       LOCAL   hDC  :DWORD
       LOCAL   lpTxt:DWORD
       LOCAL   nmh  :NMHDR    
       LOCAL   Rct  :RECT
       LOCAL   Ps   :PAINTSTRUCT
       LOCAL   tbab :TBADDBITMAP
       LOCAL   tbb  :TBBUTTON
       LOCAL   buffer1[128]   :BYTE
       LOCAL   FileBuffer[260]:BYTE
       LOCAL   sbParts[4]     :DWORD

       .if uMsg == WM_COMMAND
;        Toolbar Commands
;        ------------------------------
         .if wParam == 50
           jmp     NewFile
         .elseif wParam == 51
           jmp     FileOpen
         .elseif wParam == 52
           jmp     FileSave
         .elseif wParam == 53
           jmp     mnu_Cut
         .elseif wParam == 54
           jmp     mnu_Copy
         .elseif wParam == 55
           jmp     mnu_Paste
         .elseif wParam == 56
           jmp     mnu_Undo
         .elseif wParam == 57
           jmp     mnu_FindText
         .elseif wParam == 59
           jmp     QuitApp
         .elseif wParam == 60
           jmp     mnu_Print
         .elseif wParam == 61
           jmp     mnu_Redo
         .elseif wParam == 62
           jmp     mnu_Replace
         .elseif wParam == 63
           jmp     mnu_Delete
         .elseif wParam == 66
           jmp     mnu_WordWrap

;        Menu Commands
;        ------------------------------;
         .elseif wParam == 1000        ; New
NewFile:   invoke  Confirmation, hRichEd
           .if eax == IDYES
             jmp     FileSave
           .elseif eax == IDNO
             jmp     @F
           .elseif eax == IDCANCEL
             return  0
           .endif
@@:        invoke  SendMessage, hWin, WM_SETTEXT, 0, ADDR Untitled
           invoke  SendMessage, hRichEd, WM_SETTEXT, 0, 0
           invoke  SendMessage, hRichEd, EM_SETMODIFY, 0, 0
;        File selected from the MRU list
;        ------------------------------
         .elseif wParam > 1200 && wParam < 1206
           mov     eax, wParam
           sub     eax, 1201
           mov     Block, 0
           .while eax > 0
             add     Block, 256
             dec     eax
           .endw
           mov     esi, offset MRUDump
           add     esi, Block
           mov     edi, offset szFileName
transfer:  mov     al, [esi]
           mov     [edi], al
           inc     esi
           inc     edi
           cmp     al,0
           jne     transfer
           or      OA, 1
           jmp     FileOpen
         .elseif wParam == 1002        ; Open
FileOpen:  call    OpenFileA
           cmp     szFileName[0], 0    ; Zero if file never opened
           je      @F
           invoke  AppendToMenu
           invoke  SetWindowText, hWin, ADDR szFileName
           invoke  EnableDisable
           mov     byte ptr Counter, 0
           invoke  QFour
           invoke  SetFocus, hRichEd
@@:      .elseif wParam == 1003        ; Save
FileSave:  and     sw1, 0
           call    SaveFile
         .elseif wParam == 1004        ; Save As
FileSaveAs:
           or      sw1, 1
           call    SaveFile
         .elseif wParam == 1005
           invoke  MergeFile, hRichEd
         .elseif wParam == 1114        ; Set Background Color
           m2m     BGCFlag, wParam
           invoke  SetBGColor
         .elseif wParam == 1008        ; Print
mnu_Print:
           invoke  PrintProc
           ret
         .elseif wParam == 1006
           invoke  DoPageSU
           ret
         .elseif wParam == 1010        ; Exit
QuitApp:   invoke  SendMessage, hWin, WM_SYSCOMMAND, SC_CLOSE, NULL

;        Edit Menu 
;        ------------------------------
         .elseif wParam == 1100
mnu_Undo:  invoke  SendMessage, hRichEd, EM_UNDO, 0, 0
         .elseif wParam == 1101
mnu_Cut:   invoke  SendMessage, hRichEd, WM_CUT, 0, 0
         .elseif wParam == 1102
mnu_Copy:  invoke  SendMessage, hRichEd, WM_COPY, 0, 0
         .elseif wParam == 1103
mnu_Paste: invoke  SendMessage, hRichEd, EM_PASTESPECIAL, CF_TEXT, 0
         .elseif wParam == 1104
mnu_Delete:
           invoke  SendMessage, hRichEd, WM_CLEAR, 0, 0
         .elseif wParam == 1105
mnu_Redo:  invoke SendMessage, hRichEd, EM_REDO, 0, 0
         .elseif wParam == 1106
mnu_FindText:
           invoke  SendMessage, hRichEd, EM_EXGETSEL, 0, offset cr
           .if cr.cpMin && cr.cpMax == -1
             .if fSize < 128
               invoke  SendMessage, hRichEd, EM_GETSELTEXT, 0, addr szFind
             .endif
           .else
             mov     eax, cr.cpMax
             sub     eax, cr.cpMin
             .if eax < 128  
               invoke  SendMessage, hRichEd, EM_GETSELTEXT, 0, addr szFind
             .endif
           .endif
           invoke  CreateDialogParam, hInstance, 4901, hWnd, addr FindReplace, 0
           cmp     eax, 0              ; Canceled?
           je      Ret0                ; yes, then return
           invoke  SetDlgItemText, hFRDlg, 101, addr szFind
           invoke  GetDlgItem, hFRDlg, 101
           invoke  SendMessage, eax, EM_SETSEL, 0, -1
         .elseif wParam == 1110
mnu_Replace:
           invoke  SendMessage, hRichEd, EM_EXGETSEL, 0, offset cr
           .if cr.cpMin && cr.cpMax == -1
             .if fSize < 128
               invoke  SendMessage, hRichEd, EM_GETSELTEXT, 0, addr szFind
             .endif
           .else
             mov     eax, cr.cpMax
             sub     eax, cr.cpMin
             .if eax < 128  
               invoke  SendMessage, hRichEd, EM_GETSELTEXT, 0, addr szFind
             .endif
           .endif
           invoke  CreateDialogParam, hInstance, 4902, hWnd, addr FindReplace, 0
           cmp     eax, 0              ; Canceled?
           je      Ret0                ; yes, then return
           invoke  SetDlgItemText, hFRDlg, 101, addr szFind
           invoke  GetDlgItem, hFRDlg, 101
           invoke  SendMessage, eax, EM_SETSEL, 0, -1
         .elseif wParam == 1107 || wParam == 1112
mnu_FindNext:
           mov     eax, wParam
           and     Prev, 0
           mov     FRFlags, 1
           mov     ft.chrg.cpMax, -1
           .if eax == 1112
             mov     Prev, 1
             and     FRFlags, 0
             mov     ft.chrg.cpMax, 0
           .endif
           invoke  SendMessage, hRichEd, EM_GETSELTEXT, 0, addr szFind
           test    eax, eax
           jz      Ret0
           invoke  SendMessage, hRichEd, EM_EXGETSEL, 0, addr ft.chrgText
           .if !Prev
             inc     ft.chrgText.cpMin
           .endif
           m2m     ft.chrg.cpMin, ft.chrgText.cpMin
           lea     eax, offset szFind
           mov     ft.lpstrText, eax
           invoke  Find, hWnd, 1, FRFlags, ft.lpstrText, Prev
         .elseif wParam == 1108        ; Select All
           invoke  Select_All, hRichEd
         .elseif wParam == 1109
           invoke  Font
           ret
         .elseif wParam == 1111        ; WordWrap
mnu_WordWrap:
           invoke  WordWrap
           ret
         .elseif wParam == 1900        ; About
           szText  RichEd, "FreeWare Editor"
           szText  AboutMsg, "Bible Search Utility 1.0.0, by: Paul E. Brennick",13,10,\
                   "Copyright Tasc Development - 2001"
           invoke  ShellAbout, hWin, ADDR RichEd, ADDR AboutMsg, hIcon
         .elseif wParam == 1025
           invoke  DialogBoxParam, hInstance, ADDR SpecialDLGName, 0, ADDR SpecialProc, 0
           ret
         .endif
; End of menu commands
;--------------------------------------
       .elseif uMsg == WM_NOTIFY
;        ------------------------------
;        The toolbar has the TBSTYLE_TOOLTIPS
;        style enabled so that a WM_NOTIFY
;        message is sent when the mouse is
;        over the toolbar buttons.
;        ------------------------------
         mov     eax, lParam
         mov     eax, [eax]      ; get 1st member of NMHDR structure "hwndFrom"
         .if eax == hToolTips
           .if wParam == 50
             mov     lpTxt, offset tbn_new
           .elseif wParam == 51
             mov     lpTxt, offset tbn_open
           .elseif wParam == 52
             mov     lpTxt, offset tbn_save
           .elseif wParam == 60
             mov     lpTxt, offset tbn_print
           .elseif wParam == 53
             mov     lpTxt, offset tbn_cut
           .elseif wParam == 54
             mov     lpTxt, offset tbn_copy
           .elseif wParam == 55
             mov     lpTxt, offset tbn_paste
           .elseif wParam == 56
             mov     lpTxt, offset tbn_undo
           .elseif wParam == 61
             mov     lpTxt, offset tbn_redo
           .elseif wParam == 57
             mov     lpTxt, offset tbn_find
           .elseif wParam == 62
             mov     lpTxt, offset tbn_replace
           .elseif wParam == 63
             mov     lpTxt, offset tbn_delete
           .elseif wParam == 66
             mov     lpTxt, offset tbn_wwrap
           .elseif wParam == 59
             mov     lpTxt, offset tbn_quit
           .endif
         .else
           mov     lpTxt, offset tbn_else
         .endif
         invoke  SendMessage, hStatus, SB_SETTEXT, 2, lpTxt
@@:    .elseif uMsg == WM_DROPFILES
         invoke  DragQueryFile, wParam, 0, ADDR FileBuffer, LENGTHOF FileBuffer
         invoke  Confirmation, hRichEd
         .if eax == IDYES
           jmp     FileSave
         .elseif eax == IDCANCEL
           return  0
         .endif
         invoke  StreamFileIn, hRichEd, ADDR FileBuffer
         invoke  SendMessage, hRichEd, EM_SETMODIFY, 0, 0
         invoke  SendMessage, hWin, WM_SETTEXT, 0, ADDR FileBuffer
         return  0
       .elseif uMsg == WM_SYSCOLORCHANGE
         invoke  Do_ToolBar, hWin
       .elseif uMsg == WM_CREATE
         invoke  Do_ToolBar, hWin
         invoke  Do_Status, hWin
         invoke  LoadLibrary, ADDR ReDLL
         invoke  EditControl, hWin, 0, 40, 250, 250, 800
         mov     hRichEd, eax
         invoke  SendMessage, hRichEd, EM_SETEVENTMASK, 0, ENM_CHANGE or ENM_SELCHANGE or\
                 ENM_MOUSEEVENTS or ENM_KEYEVENTS or ENM_DROPFILES
         invoke  SetBGColor
       .elseif uMsg == WM_SETFOCUS
         invoke  SetFocus, hRichEd
       .elseif uMsg == WM_SIZE
         invoke  SendMessage, hToolBar, TB_AUTOSIZE, 0, 0
         invoke  MoveWindow, hStatus, 0, 0, 0, 0, TRUE
;        ------------------------------
;        Get toolbar & statusbar heights,
;        get window client area size and
;        position edit window in remaining
;        client area.
;        ------------------------------
         invoke  GetClientRect, hToolBar, ADDR Rct
         mov     eax, Rct.bottom
         mov     hTbar, eax
         invoke  GetClientRect, hStatus, ADDR Rct
         mov     eax, Rct.bottom
         mov     hSbar, eax
         invoke  GetClientRect, hWin, ADDR Rct
         mov     eax, Rct.bottom
         sub     eax, hTbar
         sub     eax, hSbar
;        ------------------------------
;        Drop edit window by 2 pixels
;        to display toolbar properly
;        ------------------------------
         add     hTbar, 2
         sub     eax, 2
         invoke  MoveWindow, hRichEd, 0, hTbar, Rct.right, eax, TRUE
         invoke  GetClientRect, hStatus, ADDR Rct
         mov     eax, Rct.right
         shr     eax, 2                  ; /4, width of first part
         mov     ebx, eax
;        --------------------------------
;        sbParts is a DWORD array of 4 members
;        --------------------------------;
         mov     [sbParts +  0],   eax   ; pixels from left
         add     eax, ebx                ;
         mov     [sbParts +  4],   eax   ; pixels from left
         add     eax, ebx                ;
         mov     [sbParts +  8],   eax   ; pixels from left
         mov     [sbParts + 12],    -1   ; last part is what is left
         invoke  SendMessage, hStatus, SB_SETPARTS, 4, ADDR sbParts
       .elseif uMsg == WM_CLOSE
         invoke  Confirmation, hRichEd
         .if eax == IDYES
           jmp     FileSave
         .elseif eax == IDCANCEL
           return  0
         .endif
       .elseif uMsg == WM_DESTROY
         invoke  PostQuitMessage, NULL
         return  0 
       .endif
       invoke  DefWindowProc, hWin, uMsg, wParam, lParam
Ret0:  ret
;--------------------------------------
WndProc  endp


ShowPosition  proc
;--------------------------------------;
       invoke  SendMessage, hRichEd, EM_LINEINDEX, -1, 0
       mov     FileOff, eax            ; Offset to start of current line from beginning of file
       invoke  SendMessage, hRichEd, EM_EXLINEFROMCHAR, 0, FileOff
       mov     BinRow, eax             ; Current Row - 1
       inc     BinRow                  ; Current Row
       invoke  SendMessage, hRichEd, EM_LINEINDEX, BinRow, 0
       .if eax == -1                   ; -1 if past EOF
         mov     eax, 1                ; If so, then make it a 1
       .endif
       mov     BinColumnTotal, eax     ; Offset to start of next line from beginning of file
       invoke  SendMessage, hRichEd, EM_GETLINECOUNT, 0, 0
       mov     BinRowTotal, eax        ; Total amount of lines in editor
       invoke  SendMessage, hRichEd, EM_GETSEL, offset BinColumn, offset BinColOffset
       push    BinColOffset            ; Save position within the line
       push    FileOff                 ; Save position of line start - 1
       pop     eax                     ; Now in eax register
       pop     BinColumn               ; Get position within the line
       sub     BinColumn, eax          ; Get column position - 1
       inc     BinColumn               ; Current Column
       .if BinColumnTotal == 1         ; If current line is last line...
         mov     eax, BinColumn        ; Then get Column
         mov     BinColumnTotal, eax   ; and Make it the max value
       .else                           ; Else
         push    FileOff               ; Save position of line start - 1 
         pop     eax                   ; Now in eax
         sub     BinColumnTotal, eax   ; Get column position
       .endif                          ;
;      --------------------------------;
;      The next 6 lines convert all the
;      variables to decimal from hex and
;      displays them in the Status Bar.
;      --------------------------------;
       mov     ShowRow[0], 0
       invoke  szCatStr, ADDR ShowRow, ADDR RowMsg
       invoke  dwtoa, BinRow, ADDR Row
       invoke  szCatStr, ADDR ShowRow, ADDR Row
       invoke  szCatStr, ADDR ShowRow, ADDR OfMsg
       invoke  dwtoa, BinRowTotal, ADDR RowTotal
       invoke  szCatStr, ADDR ShowRow, ADDR RowTotal
       mov     ShowColumn[0], 0
       invoke  szCatStr, ADDR ShowColumn, ADDR ColumnMsg
       invoke  dwtoa, BinColumn, ADDR Column
       invoke  szCatStr, ADDR ShowColumn, ADDR Column
       invoke  szCatStr, ADDR ShowColumn, ADDR OfMsg
       invoke  dwtoa, BinColumnTotal, ADDR ColumnTotal
       invoke  szCatStr, ADDR ShowColumn, ADDR ColumnTotal
       invoke  SendMessage, hStatus, SB_SETTEXT, 0, addr ShowRow
       invoke  SendMessage, hStatus, SB_SETTEXT, 1, addr ShowColumn
       ret                             ;
;--------------------------------------;
ShowPosition  endp


TopXY  proc  wDim:DWORD,
             sDim:DWORD
;--------------------------------------;
       shr sDim, 1                     ; Divide screen dimension by 2
       shr wDim, 1                     ; Divide window dimension by 2
       mov eax, wDim                   ; Copy window dimension into eax
       sub sDim, eax                   ; Sub half win dimension from half screen dimension
       return sDim                     ;
;--------------------------------------;
TopXY  endp


EditControl  proc  hParent:DWORD,
                   x      :DWORD,
                   y      :DWORD,
                   wd     :DWORD,
                   ht     :DWORD,
                   ID     :DWORD
;--------------------------------------
       LOCAL   hEdit:DWORD

       .if szWWrap == 0                ; Word Wrap is enabled
         mov     szWWrap, 1
         invoke  CheckMenuItem, hMnu, IDM_WWRAP, MF_CHECKED
         invoke  CreateWindowEx, 0, ADDR EditMl, 0, WS_VISIBLE or ES_SUNKEN or \
                 WS_CHILDWINDOW or WS_CLIPSIBLINGS or ES_MULTILINE or WS_VSCROLL or \
                 ES_AUTOVSCROLL or ES_NOHIDESEL, x, y, wd, ht, hParent, ID, hInstance, NULL
       .else                           ; Word Wrap is disabled
         mov     szWWrap, 0
         invoke  CheckMenuItem, hMnu, IDM_WWRAP, MF_UNCHECKED
         invoke  CreateWindowEx, 0, ADDR EditMl, 0, WS_VISIBLE or ES_SUNKEN or WS_CHILDWINDOW or \
                 WS_CLIPSIBLINGS or ES_MULTILINE or WS_VSCROLL or ES_AUTOVSCROLL or WS_HSCROLL or \
                 ES_AUTOHSCROLL or ES_NOHIDESEL, x, y, wd, ht, hParent, ID, hInstance, NULL
       .endif
       mov     hEdit, eax
       invoke  SetWindowLong, hEdit, GWL_WNDPROC, hEditProc
       mov     lpfnhEditProc, eax
       invoke  SendMessage, hEdit, WM_SETFONT, NULL, 0
       invoke  SendMessage, hEdit, EM_EXLIMITTEXT, 0, 100000000
       invoke  SendMessage, hEdit, EM_SETOPTIONS, ECOOP_XOR, ECO_SELECTIONBAR
       mov     eax, hEdit
       ret
;--------------------------------------
EditControl  endp


hEditProc  proc  hCtl  :DWORD,
                 uMsg  :DWORD,
                 wParam:DWORD,
                 lParam:DWORD
;--------------------------------------
       LOCAL Pt :POINT
       LOCAL hSM:DWORD

       .if uMsg == WM_KEYUP
;        ------------------------------
;        Process the F1 to F3 keys
;        ------------------------------
         .if wParam == VK_F1
;          ----------------------------
;          Impliment Help code here
;          ----------------------------
         .elseif wParam == VK_F2
           invoke  SendMessage, hRichEd, EM_EXGETSEL, 0, offset cr
           .if cr.cpMin && cr.cpMax == -1
             .if fSize < 128
               invoke  SendMessage, hRichEd, EM_GETSELTEXT, 0, addr szFind
             .endif
           .else
             mov     eax, cr.cpMax
             sub     eax, cr.cpMin
             .if eax < 128  
               invoke  SendMessage, hRichEd, EM_GETSELTEXT, 0, addr szFind
             .endif
           .endif
           invoke  CreateDialogParam, hInstance, 4901, hWnd, addr FindReplace, 0
           cmp     eax, 0          ; Canceled?
           je      CrappedOut      ; yes, then return
           invoke  SetDlgItemText, hFRDlg, 101, addr szFind
           invoke  GetDlgItem, hFRDlg, 101
           invoke  SendMessage, eax, EM_SETSEL, 0, -1
CrappedOut:
           return  0
         .elseif wParam == VK_F3
           and     Prev, 0
           mov     FRFlags, 1
           mov     ft.chrg.cpMax, -1
           .if eax == 1112
             mov     Prev, 1
             and     FRFlags, 0
             mov     ft.chrg.cpMax, 0
           .endif
           invoke  SendMessage, hRichEd, EM_EXGETSEL, 0, offset cr
           .if cr.cpMin && cr.cpMax == -1
             .if fSize < 128
               invoke  SendMessage, hRichEd, EM_GETSELTEXT, 0, addr szFind
               test    eax, eax
               jz      CrappedOut 
             .endif
           .else
             mov     eax, cr.cpMax
             sub     eax, cr.cpMin
             .if eax < 128  
               invoke  SendMessage, hRichEd, EM_GETSELTEXT, 0, addr szFind
               test    eax, eax
               jz      CrappedOut 
             .endif
           .endif
           invoke  SendMessage, hRichEd, EM_EXGETSEL, 0, addr ft.chrgText
           .if !Prev
             inc     ft.chrgText.cpMin
           .endif
           m2m     ft.chrg.cpMin, ft.chrgText.cpMin
           lea     eax, offset szFind
           mov     ft.lpstrText, eax
           invoke  Find, hWnd, 1, FRFlags, ft.lpstrText, Prev
         .elseif wParam == VK_F4
           invoke  SendMessage, hRichEd, EM_EXGETSEL, 0, offset cr
           .if cr.cpMin && cr.cpMax == -1
             .if fSize < 128
               invoke  SendMessage, hRichEd, EM_GETSELTEXT, 0, addr szFind
             .endif
           .else
             mov     eax, cr.cpMax
             sub     eax, cr.cpMin
             .if eax < 128  
               invoke  SendMessage, hRichEd, EM_GETSELTEXT, 0, addr szFind
             .endif
           .endif
           invoke  CreateDialogParam, hInstance, 4902, hWnd, addr FindReplace, 0
           cmp     eax, 0              ; Canceled?
           je      CrappedOut          ; yes, then return
           invoke  SetDlgItemText, hFRDlg, 101, addr szFind
           invoke  GetDlgItem, hFRDlg, 101
           invoke  SendMessage, eax, EM_SETSEL, 0, -1
         .endif
       .elseif uMsg == WM_RBUTTONDOWN
         invoke  GetCursorPos, ADDR Pt
         invoke  GetSubMenu, hMnu, menu_popup
         mov     hSM, eax
         invoke  TrackPopupMenu, hSM, TPM_LEFTALIGN or TPM_LEFTBUTTON,
                 Pt.x, Pt.y, 0, hWnd, NULL
       .endif
       invoke  CallWindowProc, lpfnhEditProc, hCtl, uMsg, wParam, lParam
       ret
;--------------------------------------
hEditProc  endp


Do_ToolBar  proc  hWin:DWORD
;      --------------------------------
;      This proc works by using macros
;      so that the code is easier to
;      read and modify.
;      --------------------------------
       LOCAL   bSize:DWORD
       LOCAL   tbab :TBADDBITMAP
       LOCAL   tbb  :TBBUTTON
;      --------------------------------
;      The toolbar bitmap
;      --------------------------------
;      You must supply a bitmap for the
;      toolbar that has the correct number
;      of the required images, each of
;      the same size and in the following
;      strip bitmap form.
;      -------------------------------------
;      |  1  |  2  |  3  |  4  |  5  |  6  |
;      -------------------------------------
;      Uncomment following when
;      bitmap has been created
;      --------------------------------
       invoke  LoadBitmap,hInstance,2000
       mov     hTbBmp,eax
;      --------------------------------
;      Set toolbar button dimensions
;      here, width & height
;      --------------------------------;
       Create_Tool_Bar 25, 25          ;
       TBextraData                     ; Additional data for TBBUTTON structure
;      --------------------------------
;      Add toolbar buttons and spaces
;      here.  Syntax for the macro
;      TBbutton is TBbutton bmpID number,
;      WM_COMMAND ID number.  WM_COMMAND
;      ID numbers start at 50.
;      --------------------------------
       TBblank
       TBbutton    0,  50
       TBbutton    1,  51
       TBbutton    2,  52
       TBbutton    3,  60
       TBblank
       TBbutton    4,  53
       TBbutton    5,  54
       TBbutton    6,  55
       TBbutton    7,  63
       TBblank
       TBbutton    8,  56
       TBbutton    9,  61
       TBbutton    10, 57
       TBbutton    11, 62
       TBblank
       TBbutton    12, 66
       TBblank
       TBbutton    13, 59
       ret
;--------------------------------------
Do_ToolBar  endp


SetBmpColor  proc  hBitmap:DWORD
;--------------------------------------
       LOCAL   mDC      :DWORD
       LOCAL   hBrush   :DWORD
       LOCAL   hOldBmp  :DWORD
       LOCAL   hReturn  :DWORD
       LOCAL   hOldBrush:DWORD

       invoke  CreateCompatibleDC, NULL
       mov     mDC,eax
       invoke  SelectObject, mDC, hBitmap
       mov     hOldBmp, eax
       invoke  GetSysColor, COLOR_BTNFACE
       invoke  CreateSolidBrush, eax
       mov     hBrush, eax
       invoke  SelectObject, mDC, hBrush
       mov     hOldBrush, eax
       invoke  GetPixel, mDC, 1, 1
       invoke  ExtFloodFill, mDC, 1, 1, eax, FLOODFILLSURFACE
       invoke  SelectObject, mDC, hOldBrush
       invoke  DeleteObject, hBrush
       invoke  SelectObject, mDC, hBitmap
       mov     hReturn, eax
       invoke  DeleteDC, mDC
       mov     eax, hReturn
       ret
;--------------------------------------
SetBmpColor  endp


Do_Status  proc  hParent:DWORD
;--------------------------------------
       LOCAL   sbParts[4]:DWORD
       LOCAL   Rct       :RECT

       invoke  CreateStatusWindow, WS_CHILD or WS_VISIBLE or \
               SBS_SIZEGRIP, NULL, hParent, 200
       mov     hStatus, eax
       invoke  GetClientRect, hStatus, ADDR Rct
       mov     eax, Rct.right
       shr     eax, 2                  ; /4, width of first part
       mov     ebx, eax
;      --------------------------------
;      sbParts is a DWORD array of 4 members
;      --------------------------------;
       mov     [sbParts +  0],   eax   ; pixels from left
       add     eax, ebx                ;
       mov     [sbParts +  4],   eax   ; pixels from left
       add     eax, ebx                ;
       mov     [sbParts +  8],   eax   ; pixels from left
       mov     [sbParts + 12],    -1   ; last part is what is left
       invoke  SendMessage, hStatus, SB_SETPARTS, 4, ADDR sbParts
       ret                             ;
;--------------------------------------;
Do_Status  endp


ofCallBack  proc  dwCookie:DWORD,
                  pbBuff  :DWORD,
                  cb      :DWORD,
                  pcb     :DWORD
;--------------------------------------
       invoke  ReadFile, dwCookie, pbBuff, cb, pcb, NULL
       mov     eax, 0
       ret
;--------------------------------------
ofCallBack endp


StreamFileIn  proc  hEdit       :DWORD,
                    lpszFileName:DWORD
;--------------------------------------
       LOCAL   fSiz  :DWORD
       LOCAL   ofs   :OFSTRUCT
       LOCAL   est   :EDITSTREAM

       invoke  OpenFile, lpszFileName, ADDR ofs, OF_READ
       mov     hFile, eax
       mov     est.dwCookie, eax
       mov     est.dwError, 0
       mov     eax, offset ofCallBack
       mov     est.pfnCallback, eax
       invoke  SendMessage, hEdit, EM_STREAMIN, SF_TEXT, ADDR est
       mov     fSize, eax
       invoke  CloseHandle, hFile
       mov     fSizeBuffer[0], 0
       mov     ShowfSize[0], 0
       invoke  szCatStr, ADDR ShowfSize, ADDR OpenMsg
       invoke  dwtoa, fSize, ADDR fSizeBuffer
       invoke  szCatStr, ADDR ShowfSize, ADDR fSizeBuffer
       invoke  szCatStr, ADDR ShowfSize, ADDR OpenByt
       invoke  SendMessage, hEdit, EM_SETMODIFY, 0, 0
       mov     eax, 0
       ret
;--------------------------------------
StreamFileIn  endp


MergeFile  proc  hEdit:DWORD
;--------------------------------------
       LOCAL   poz  :DWORD
       LOCAL   hMem :DWORD
       LOCAL   ln   :DWORD
       LOCAL   br   :DWORD
       LOCAL   Cr   :CHARRANGE

       mov     szFileName[0], 0
       invoke  GetFileName, hWnd, ADDR szTitleM, ADDR szFilter
       cmp     szFileName[0], 0        ; zero if cancel pressed in dlgbox
       je @F
       invoke  CreateFile, ADDR szFileName, GENERIC_READ, FILE_SHARE_READ,
               NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
       mov     hFile, eax
       invoke  GetFileSize, hFile, NULL
       mov     ln, eax
       stralloc    ln
       mov     hMem, eax
       invoke  ReadFile, hFile, hMem, ln, ADDR br, NULL
       invoke  SendMessage, hEdit, EM_REPLACESEL, 0, hMem
       strfree hMem
@@:    ret
;--------------------------------------
MergeFile  endp


GetFileName  proc  hParent :DWORD,
                   lpTitle :DWORD,
                   lpFilter:DWORD
;--------------------------------------
       mov     ofn.lStructSize, sizeof OPENFILENAME
       m2m     ofn.hWndOwner,   hParent
       m2m     ofn.hInstance,   hInstance
       m2m     ofn.lpstrFilter, lpFilter
       m2m     ofn.lpstrFile,   offset szFileName
       mov     ofn.nMaxFile,    sizeof szFileName
       m2m     ofn.lpstrTitle,  lpTitle
       mov     ofn.Flags,       OFN_EXPLORER or OFN_FILEMUSTEXIST or \
                                OFN_LONGNAMES
       invoke  GetOpenFileName, ADDR ofn
       cmp     eax, 0
       jne     done
       mov     szFileName[0], 0
done:  ret
;--------------------------------------
GetFileName  endp


SaveFileName  proc  hParent :DWORD,
                    lpTitle :DWORD,
                    lpFilter:DWORD
;--------------------------------------
       mov     ofn.lStructSize, sizeof OPENFILENAME
       m2m     ofn.hWndOwner,   hParent
       m2m     ofn.hInstance,   hInstance
       m2m     ofn.lpstrFilter, lpFilter
       m2m     ofn.lpstrFile,   offset szFileName
       mov     ofn.nMaxFile,    sizeof szFileName
       m2m     ofn.lpstrTitle,  lpTitle
       mov     ofn.Flags,       OFN_EXPLORER or OFN_LONGNAMES
       invoke  GetSaveFileName, ADDR ofn
       cmp     eax, 0
       je      done
       push    eax
       invoke  AppendToMenu
       pop     eax
done:  ret
;--------------------------------------
SaveFileName  endp


Select_All  Proc  hEdit:DWORD
;--------------------------------------
       LOCAL   tl:DWORD
       LOCAL   Cr:CHARRANGE

       mov     Cr.cpMin,0
       invoke  GetWindowTextLength, hEdit
       inc     eax
       mov     Cr.cpMax, eax
       invoke  SendMessage, hEdit, EM_EXSETSEL, 0, ADDR Cr
       ret
;--------------------------------------
Select_All  endp


Confirmation  proc  hEditor:DWORD
;--------------------------------------
       invoke  SendMessage, hEditor, WM_GETTEXTLENGTH, 0, 0
       cmp     eax, 0
       jne     @F
       return  0
@@:    invoke  SendMessage, hEditor, EM_GETMODIFY, 0, 0
       cmp     eax, 0  ; zero = unmodified
       jne     @F
       return  0
@@:    invoke  MessageBox, hWnd, ADDR confirm,
               ADDR szDisplayName, MB_YESNOCANCEL or MB_ICONQUESTION
       ret
;--------------------------------------
Confirmation  endp


;--------------------------------------;
; Enable or disable the items in the   ;
; Edit Menu and Toolbar                ;
;--------------------------------------;
EnableDisable  PROC
;--------------------------------------
       LOCAL   TWord1:DWORD
       LOCAL   TWord2:DWORD

       mov     TWord2, TRUE
       invoke  SendMessage, hRichEd, EM_CANUNDO, 0, 0
       cmp     eax, TRUE
       jne     EdMu1
       mov     TWord1, MF_ENABLED
       jmp     EdMu2
EdMu1: mov     TWord1, MF_GRAYED
       mov     TWord2, FALSE
EdMu2: invoke  EnableMenuItem, hMnu, 1100, TWord1
       invoke  SendMessage, hToolBar, TB_ENABLEBUTTON, 56, TWord2
       invoke  SendMessage, hRichEd, EM_CANREDO, 0, 0
       cmp     eax, TRUE
       jne     EdMu3
       mov     TWord1, MF_ENABLED
       mov     TWord2, TRUE
       jmp     EdMu4
EdMu3: mov     TWord1, MF_GRAYED
       mov     TWord2, FALSE
EdMu4: invoke  EnableMenuItem, hMnu, 1105, TWord1
       invoke  SendMessage, hToolBar, TB_ENABLEBUTTON, 61, TWord2
       invoke  IsClipboardFormatAvailable, CF_TEXT
       cmp     eax, TRUE
       jne     EdMu5
       mov     TWord1, MF_ENABLED
       mov     TWord2, TRUE
       jmp     EdMu6
EdMu5: mov     TWord1, MF_GRAYED
       mov     TWord2, FALSE
EdMu6: invoke  EnableMenuItem, hMnu, 1103, TWord1
       invoke  SendMessage, hToolBar, TB_ENABLEBUTTON, 55, TWord2
       invoke  SendMessage, hRichEd, EM_EXGETSEL, 0, offset cr
       mov     eax, cr.cpMax
       sub     eax, cr.cpMin
       cmp     eax, 0
       je      EdMu7
       mov     TWord1, MF_ENABLED
       mov     TWord2, TRUE
       jmp     EdMu8
EdMu7: mov     TWord1, MF_GRAYED
       mov     TWord2, FALSE
EdMu8: invoke  EnableMenuItem, hMnu, 1101, TWord1
       invoke  EnableMenuItem, hMnu, 1102, TWord1
       invoke  EnableMenuItem, hMnu, 1104, TWord1
       invoke  SendMessage, hToolBar, TB_ENABLEBUTTON, 53, TWord2
       invoke  SendMessage, hToolBar, TB_ENABLEBUTTON, 54, TWord2
       invoke  SendMessage, hToolBar, TB_ENABLEBUTTON, 63, TWord2
       ret
;--------------------------------------
EnableDisable  ENDP


;--------------------------------------;
; Print document procedure             ;
;--------------------------------------;
PrintProc  PROC
;--------------------------------------
       LOCAL   Chg:DWORD
       LOCAL   TextSize

       .if PageSUFlag == 0
         invoke  DoPageSU
       .endif
       invoke  SendMessage, hRichEd, EM_GETMODIFY, 0, 0
       mov     Chg, eax
StartPrt:
       mov     pd.lStructSize, SIZEOF pd
       mov     eax, hWnd
       mov     pd.hWndOwner, eax
       mov     eax, hInstance
       mov     pd.hInstance, eax
       mov     pd.Flags, PD_RETURNDC
       invoke  PrintDlg, offset pd
       cmp     eax, FALSE
       je      Prtret
       mov     eax, pd.Flags
       mov     ebx, eax
       and     ebx, 000000ffh
       mov     Sel, ebx
       invoke  SendMessage, hRichEd, EM_EXGETSEL, 0, offset cr
       mov     eax, cr.cpMax
       .if eax > cr.cpMin && Sel != 1
         invoke  MessageBox, NULL, ADDR szSelect, NULL, MB_YESNO or MB_ICONQUESTION
         cmp     eax, IDNO
         je      Prtret
       .endif
       mov     doci.cbSize, sizeof doci
       mov     doci.lpszDocName, offset pTitle
       mov     doci.lpszOutput, 0
       mov     doci.fwType, 0
       mov     eax, pd.hDC
       mov     fr.hdc, eax
       mov     fr.hdcTarget, eax       ; 0
       invoke  GetDeviceCaps, fr.hdc, LOGPIXELSX
       mov     xPerInch, eax           ; Number of pixels per logical inch along the screen width.
       invoke  GetDeviceCaps, fr.hdc, LOGPIXELSY
       mov     yPerInch, eax           ; Number of pixels per logical inch along the screen height.
       mov     eax, mL                 ; Minimum is 360
       mov     rect.left, eax
       mov     eax, mT                 ; Minimum is 360
       mov     rect.top, eax
       invoke  GetDeviceCaps, fr.hdc, HORZRES
       mov     ecx, 1440               ; Width, in pixels, of the screen.
       mul     ecx
       div     xPerInch
       mov     rect.right, eax
       mov     eax, mR                 ; Minimum is 360
       sub     rect.right, eax
       invoke  GetDeviceCaps, fr.hdc, VERTRES
       mov     ecx, 1440               ; Height, in raster lines, of the screen.
       mul     ecx
       div     yPerInch
       mov     rect.bottom, eax
       mov     eax, mB                 ; Minimum is 302
       sub     rect.bottom, eax
       mov     ecx, 16
       mov     edi, offset fr.rcPage
       mov     esi, offset rect
       cld
       rep     movsb
       invoke  StartDoc, pd.hDC, offset doci
       invoke  SendMessage, hRichEd, EM_EXGETSEL, 0, offset cr
       mov     eax, cr.cpMin
       mov     ebx, cr.cpMax
       .if ebx > eax && Sel == 1
         mov     fr.chrg.cpMin, eax
         mov     fr.chrg.cpMax, ebx
         mov     TextSize, ebx
       .else
         invoke  SendMessage, hRichEd, EM_HIDESELECTION, 1, 0
         mov     cr.cpMin, 0
         mov     cr.cpMax, -1
         invoke  SendMessage, hRichEd, EM_EXSETSEL, 0, offset cr
         invoke  SendMessage, hRichEd, EM_EXGETSEL, 0, offset cr
         m2m     fr.chrg.cpMin, cr.cpMin
         mov     fr.chrg.cpMax, -1
         m2m     TextSize, cr.cpMax 
         mov     cr.cpMin, 0
         mov     cr.cpMax, 0
         invoke  SendMessage, hRichEd, EM_EXSETSEL, 0, offset cr
         invoke  SendMessage, hRichEd, EM_HIDESELECTION, 0, 0
       .endif
prtloop:
       invoke  StartPage, pd.hDC
       cmp     eax, 0
       jle     prtabort
       mov     ecx, 16
       mov     esi, offset rect
       mov     edi, offset fr.rc       ; Actual print page dimensions
       cld
       rep     movsb
       invoke  SendMessage, hRichEd, EM_FORMATRANGE, TRUE, offset fr
       mov     fr.chrg.cpMin, eax      ; Print page
       invoke  EndPage, pd.hDC
       cmp     eax, 0
       jle     prtabort
       mov     eax, fr.chrg.cpMin
       cmp     eax, 0
       jle     prtdone
       cmp     eax, TextSize
       jl      prtloop
prtdone:
       invoke  SendMessage, hRichEd, EM_FORMATRANGE, 0, 0
       invoke  EndDoc, pd.hDC
       invoke  DeleteDC, pd.hDC
       jmp     Prtret
prtabort:
       invoke  AbortDoc, fr.hdc
Prtret:
       invoke  SendMessage, hRichEd, EM_SETMODIFY, Chg, 0
       ret
;--------------------------------------
PrintProc  ENDP


;--------------------------------------;
; Page Setup Dialog Procedure          ;
;--------------------------------------;
DoPageSU   PROC
;--------------------------------------
       mov     psd.lStructSize, SIZEOF psd
       push    hWnd
       pop     psd.hwndOwner
       push    hInstance
       pop     psd.hInstance
       mov     psd.flags, PSD_DISABLEORIENTATION or PSD_INTHOUSANDTHSOFINCHES or PSD_DISABLEPAPER or PSD_DISABLEPRINTER
       invoke  PageSetupDlg, offset psd
       cmp     eax,0
       jz      NSU
       finit
       mov     al, psd.rtMargin[0]
       mov     ah, psd.rtMargin[1]
       and     eax, 0000ffffh
       mov     w1, eax
       fld     RTwips1000
       fild    w1
       fmul    ST(0), ST(1)
       fistp   mL
       mov     al, psd.rtMargin[4]
       mov     ah, psd.rtMargin[5]
       and     eax, 0000ffffh
       mov     w1, eax
       fld     RTwips1000
       fild    w1
       fmul    ST(0), ST(1)
       fistp   mT
       mov     al, psd.rtMargin[8]
       mov     ah, psd.rtMargin[9]
       and     eax, 0000ffffh
       mov     w1, eax
       fld     RTwips1000
       fild    w1
       fmul    ST(0), ST(1)
       fistp   mR
       mov     al, psd.rtMargin[12]
       mov     ah, psd.rtMargin[13]
       and     eax, 0000ffffh
       mov     w1, eax
       fld     RTwips1000
       fild    w1
       fmul    ST(0), ST(1)
       fistp   mB
       sub     mL, 360
       sub     mT, 360
       sub     mR, 360
       sub     mB, 302
       mov     PageSUFlag, 1
NSU:   ret
;--------------------------------------
DoPageSU   ENDP


;--------------------------------------;
; Change Font Procedure                ;
;--------------------------------------;
Font   PROC
;--------------------------------------
       LOCAL   Base:DWORD

       invoke  SendMessage, hRichEd, EM_GETCHARFORMAT, TRUE, offset charF
       invoke  GetDC, hWnd
       push    eax
       invoke  GetDeviceCaps, eax, LOGPIXELSY
       mov     tempword, eax
       pop     eax
       invoke  ReleaseDC, hWnd, eax
       mov     eax, charF.yHeight      ; =  0
       mul     tempword
       mov     ecx, 1440
       div     ecx
       neg     eax                
       mov     lf.lfHeight, eax        ; = -12
       mov     lf.lfWeight, FW_NORMAL
       mov     lf.lfItalic, FALSE
       mov     lf.lfUnderline, FALSE
       mov     lf.lfStrikeOut, FALSE
       mov     al, charF.bCharSet
       mov     lf.lfCharSet, al
       mov     al, charF.bPitchAndFamily
       mov     lf.lfPitchAndFamily, al
       invoke  lstrcpy, offset lf.lfFaceName, offset charF.szFaceName
       mov     cf.lStructSize, SIZEOF cf
       push    hWnd
       pop     cf.hWndOwner
       push    hInstance
       pop     cf.hInstance
       mov     cf.lpLogFont, offset lf 
       mov     cf.Flags, CF_BOTH or CF_INITTOLOGFONTSTRUCT or CF_FORCEFONTEXIST
       .if FirstTime != 1              ; This is different from 'never ran before'
         invoke  ChooseFont, offset cf ; Invoke common ChooseFont dialog
         cmp     eax, FALSE            ; Do nothing if Cancel button was clicked
         je      Fontret               ; No saving to Registry, either
       .else
         mov     eax, szTwipsSize      ; Get point size
         mov     cf.iPointSize, eax    ; Store it in the structure
       .endif
       invoke  SendMessage, hRichEd, EM_GETCHARFORMAT, TRUE, offset charF
       mov     charF.dwEffects, 0      ; Reset the effects, they will not be used
       mov     al, lf.lfCharSet
       mov     charF.bCharSet, al
       mov     al, lf.lfPitchAndFamily
       mov     charF.bPitchAndFamily, al
       mov     eax, cf.iPointSize      ; Get Point Size
       mov     szTwipsSize, eax        ; For storing in the Registry
       shl     eax, 1                  ; Convert from 1/10 pt to twips (which is points*20)
       mov     charF.yHeight, eax      ; Store it in the structure
       mov     szPointSize, eax        ; For storing in the Registry
       invoke  lstrcpy, ADDR FontName, ADDR lf.lfFaceName
       invoke  lstrcpy, ADDR szFontName, ADDR lf.lfFaceName
       invoke  lstrcpy, offset charF.szFaceName, offset lf.lfFaceName
       invoke  CreateFontIndirect, ADDR lf
       mov     hFont, eax              ; Save the Font just created
       invoke  SendMessage, hRichEd, WM_SETFONT, hFont, 1
       invoke  SetRegKeysz, addr szFontName, addr szKeyName, addr szFontMessage, sizeof szFontMessage
       invoke  SetRegKeyDW, addr szPointSize, addr szKeyName, addr szPointMessage
       invoke  SetRegKeyDW, addr szTwipsSize, addr szKeyName, addr szTwipsMessage
       mov     eax, szTwipsSize
       push    eax
       div     DecValue
       mov     szTwipsSize, eax
       invoke  dwtoa, szTwipsSize, ADDR ASCIIPointSize
       invoke  lstrcpy, ADDR defFontName, ADDR FontName
       invoke  lstrcat, ADDR defFontName, ADDR Delimit
       invoke  lstrcat, ADDR defFontName, ADDR ASCIIPointSize
       invoke  lstrcat, ADDR defFontName, ADDR EndOfString
       pop     szTwipsSize
Fontret:                               ;
       ret                             ; return to caller
;--------------------------------------;
Font   ENDP


;--------------------------------------;
; Save file procedure                  ;
;--------------------------------------;
SaveFile  PROC
;--------------------------------------
       cmp     sw1, 1
       je      SaveAs
       mov     al, szFileName
       cmp     al, 0
       jne     dosave2
       mov     ofn.Flags, OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST
       jmp     dosave1
SaveAs:
       mov     ofn.Flags, OFN_OVERWRITEPROMPT or OFN_CREATEPROMPT
dosave1:
       invoke  SaveFileName, hWnd, ADDR szTitleS, ADDR szFilter
       cmp     eax, FALSE  ; Cancelled or error occurred
       je      EndSave
dosave2:
       mov     dwAttr, FILE_ATTRIBUTE_ARCHIVE
       invoke  GetFileAttributes, addr szFileName
       cmp     eax, 0ffffffffh
       je      crFile                  ; saverr
       mov     dwAttr, eax
       invoke  SetFileAttributes, addr szFileName, FILE_ATTRIBUTE_ARCHIVE
crFile:
       invoke  CreateFile, ADDR szFileName,\
               GENERIC_READ or GENERIC_WRITE ,\
               FILE_SHARE_READ or FILE_SHARE_WRITE,\
               NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
       cmp     eax, -1 ; Error?
       jne     savcrok
saverr:
       invoke  MessageBox, NULL, ADDR SorryCrErr, NULL, MB_OK or MB_ICONEXCLAMATION
       jmp     EndSave
savcrok:
       mov     hFile, eax
       mov     EditS.dwCookie, eax
       mov     EditS.dwError, 0
       mov     EditS.pfnCallback, offset EditStreamWrite
       invoke  SendMessage, hRichEd, EM_STREAMOUT, SF_TEXT, offset EditS
       jmp     savclose
savclose:
       invoke  CloseHandle, hFile
       invoke  SetFileAttributes, addr szFileName, dwAttr
       invoke  SendMessage,  hRichEd, EM_SETMODIFY, FALSE, 0
       invoke  SendMessage, hWnd, WM_SETTEXT, 0, ADDR szFileName
EndSave:
       and     sw1, 0
       ret
;--------------------------------------
SaveFile  ENDP


WordWrap   PROC
;-----------------------------------------------
       invoke  SendMessage, hRichEd, EM_GETMODIFY, 0, 0
       .if eax
         and     sw1, 0
         call    SaveFile
       .endif
       invoke  DestroyWindow, hRichEd
       invoke  CheckMenuItem, hMnu, IDM_WWRAP, MF_BYCOMMAND
       and     szWWrap, 0
       .if eax == MF_CHECKED
         invoke  CheckMenuItem, hMnu, IDM_WWRAP, MF_UNCHECKED
         invoke  CreateWin, WS_EX_CLIENTEDGE, ADDR EditMl, WS_CHILD or WS_VISIBLE or ES_LEFT or ES_MULTILINE or\
                 ES_NOHIDESEL or ES_WANTRETURN or ES_SAVESEL or WS_VSCROLL or WS_HSCROLL or\
                 ES_AUTOVSCROLL or ES_AUTOHSCROLL or WS_TABSTOP,
                 0, 0, 0, 0, hWnd, ID_EDITWINDOW
       .else
         or      szWWrap, 1
         invoke  CheckMenuItem, hMnu, IDM_WWRAP, MF_CHECKED
         invoke  CreateWin, WS_EX_CLIENTEDGE, ADDR EditMl, WS_CHILD or WS_VISIBLE or ES_LEFT or ES_MULTILINE or\
                 ES_NOHIDESEL or ES_WANTRETURN or ES_SAVESEL or WS_VSCROLL or\
                 ES_AUTOVSCROLL or WS_TABSTOP,
                 0, 0, 0, 0, hWnd, ID_EDITWINDOW
       .endif
       invoke  SetBGColor
       invoke  SendMessage, hRichEd, EM_SETEVENTMASK, 0, ENM_CHANGE or ENM_SELCHANGE or\
               ENM_MOUSEEVENTS or ENM_KEYEVENTS or ENM_DROPFILES
       invoke  GetClientRect, hWnd, ADDR rect
       add     rect.top, 37
       sub     rect.bottom, 57
       invoke  MoveWindow, hRichEd, rect.left, rect.top, rect.right, rect.bottom, TRUE
       invoke  SetWindowText, hWnd, ADDR szFileName
       invoke  SetBGColor
       invoke  EnableDisable
       invoke  SetFocus, hRichEd
       test    szFileName, 0ffh
       jnz     loading
       invoke  SetWindowText, hWnd, ADDR Untitled
       ret
loading:
       or      OA, 1
       call    OpenFileA
       ret
;-----------------------------------------------
WordWrap   ENDP


;--------------------------------------;
; Check if the file needs saving and   ;
; prompt user for action               ;
;--------------------------------------;
CheckSav   PROC
;--------------------------------------
       invoke  SendMessage, hRichEd, EM_GETMODIFY, 0, 0
       cmp     eax, FALSE
       je      Checkx
       invoke  MessageBox, NULL, ADDR szSaving, NULL, MB_YESNOCANCEL or MB_ICONEXCLAMATION or MB_APPLMODAL
       cmp     eax, IDYES
       je      CheckDoSave
       ret
CheckDoSave:
       invoke  SendMessage, hWnd, WM_COMMAND, 1003, 0
Checkx:
       mov     eax, IDNO
       ret
;--------------------------------------
CheckSav   ENDP


;--------------------------------------;
; File Open                            ;
;--------------------------------------;
OpenFileA  PROC
;-----------------------------------------------
       invoke  CheckSav
       invoke  SendMessage, hRichEd, EM_SETMODIFY, FALSE, 0
       cmp     OA, 1
       je      OpenAssoc
       .if OA == 2                     ; New file?
         mov     szFileName, 0
       .endif
       invoke  GetFileName, hWnd, ADDR szTitleO, ADDR szFilter
       cmp     eax, 0                  ; Cancelled or error occurred
       je      EndOpen
       cmp     sw1, 4                  ; From executable
       je      EndOpen
OpenAssoc:     ; From file association or cmd line
       invoke  GetFileAttributes, addr szFileName
       cmp     eax, 0ffffffffh
       je      operr
       mov     dwAttr, eax
       invoke  SetFileAttributes, addr szFileName, FILE_ATTRIBUTE_ARCHIVE
       invoke  CreateFile, ADDR szFileName,\
               GENERIC_READ or GENERIC_WRITE ,\
               FILE_SHARE_READ or FILE_SHARE_WRITE,\
               NULL, OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, NULL
       cmp     eax, -1                 ; Error?
       jne     opcrok
operr:
       invoke  MessageBox, NULL, ADDR SorryOpErr, NULL, MB_OK or MB_ICONEXCLAMATION
       jmp     EndOpen
opcrok:
       mov     hFile, eax
       mov     EditS.dwCookie, eax
       mov     EditS.pfnCallback, offset EditStreamRead
       mov     EditS.dwError, 0
       invoke  SetFileAttributes, addr szFileName, dwAttr
opntxt:
       invoke  SendMessage, hRichEd, EM_STREAMIN, SF_TEXT, offset EditS
       mov     bytesread, eax
       invoke  CloseHandle, hFile
       invoke  SendMessage, hWnd, WM_SETTEXT, 0, ADDR szFileName
       invoke  SetBGColor
       invoke  SendMessage, hRichEd, EM_SETMODIFY, FALSE, 0
       invoke  SetFocus, hRichEd
EndOpen:
       invoke  SendMessage, hRichEd, EM_EMPTYUNDOBUFFER, 0, 0
       and     OA, 0
       and     sw1, 0
       ret
;-----------------------------------------------
OpenFileA  ENDP


;-----------------------------------------------;
;  Edit Stream Read Callback procedure          ;
;-----------------------------------------------;
EditStreamRead PROC    uses ebx edi esi dwCookie:DWORD, pbBuff:DWORD, cb:DWORD, pcb:DWORD
;-----------------------------------------------
       invoke  ReadFile, dwCookie, pbBuff, cb, pcb, 0
       mov     ebx, pcb
       mov     eax, [ebx]  ; Get count read so far
       cmp     eax, cb     ; compare to amount needed
       jg      Editret     ; if read < size, then more to read later
       mov     eax, 0      ; otherwise, file completely read
Editret:
       ret
;-----------------------------------------------
EditStreamRead ENDP


;-----------------------------------------------;
;  Edit Stream Save Callback procedure          ;
;-----------------------------------------------;
EditStreamWrite    PROC    dwCookie:DWORD, pbBuff:DWORD, cb:DWORD, pcb:DWORD
;-----------------------------------------------
       invoke  WriteFile, dwCookie, pbBuff, cb, pcb, 0
       mov     eax, 0  ; File completely read
       ret
;-----------------------------------------------
EditStreamWrite    ENDP


;-----------------------------------------------;
;  Create Window Procedure                      ;
;-----------------------------------------------;
CreateWin  PROC  StyleEX:DWORD,classN:DWORD,Style:DWORD,x:DWORD,y:DWORD,wd:DWORD,ht:DWORD,hwnd:DWORD,ID:DWORD
;-----------------------------------------------
       invoke  CreateWindowEx, StyleEX, classN, 0, Style, x, y, wd, ht, hwnd, ID, hInstance, 0
       cmp     eax, 0  ; Create go ok?
       jne     winok   ; yes continue
       invoke  MessageBox, NULL, ADDR Sorry, NULL, MB_OK or MB_ICONEXCLAMATION
       jmp     Createret
winok:
       mov     hRichEd, eax
       invoke  SetWindowLong, hRichEd, GWL_WNDPROC, hEditProc
       mov     lpfnhEditProc, eax
       invoke  SendMessage, hRichEd, EM_SETOPTIONS, ECOOP_XOR, ECO_SELECTIONBAR
       invoke  SendMessage, hRichEd, EM_EXLIMITTEXT, 0, 100000000
       mov     eax, szPointSize
       mov     charF.yHeight, eax
       invoke  lstrcpy, ADDR lf.lfFaceName, ADDR FontName
       invoke  lstrcpy, ADDR charF.szFaceName, ADDR FontName
       mov     FirstTime, 1
       invoke  Font
       mov     FirstTime, 0
Createret:
       ret
;-----------------------------------------------
CreateWin  ENDP


GetRegKeysz  PROC  lpszBuffer    :DWORD,
                   lpszKeyName   :DWORD, 
                   lpszValueName :DWORD,
                   dwStringLength:DWORD
;--------------------------------------
       LOCAL TType:DWORD
       LOCAL pKey :DWORD

       mov     TType, REG_SZ
       invoke  RegCreateKeyEx, HKEY_LOCAL_MACHINE, lpszKeyName, NULL, NULL, 
               REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, addr pKey, addr TType
       .if eax == ERROR_SUCCESS
         mov     eax, REG_DWORD
         mov     TType, eax
         invoke  RegQueryValueEx, pKey, lpszValueName,
                 NULL, ADDR TType, lpszBuffer, dwStringLength 
         invoke  RegCloseKey, pKey
       .endif
       ret
;--------------------------------------
GetRegKeysz  ENDP


SetRegKeysz  PROC  lpszString    :DWORD,
                   lpszKeyName   :DWORD,
                   lpszValueName :DWORD,
                   dwStringLength:DWORD
;--------------------------------------
       LOCAL Disp:DWORD
       LOCAL pKey:DWORD

       invoke  RegCreateKeyEx, HKEY_LOCAL_MACHINE, lpszKeyName, NULL, NULL, 
               REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, addr pKey, addr Disp
       .if eax == ERROR_SUCCESS
         invoke  RegSetValueEx, pKey, lpszValueName, 
                 NULL, REG_SZ, lpszString, dwStringLength 
         invoke  RegCloseKey, pKey
       .endif
       ret
;--------------------------------------
SetRegKeysz  ENDP


GetRegKeyDW  PROC  lpdwValue    :DWORD,
                   lpszKeyName  :DWORD,
                   lpszValueName:DWORD
;--------------------------------------
       LOCAL Temp     :DWORD
       LOCAL pKey     :DWORD
       LOCAL DWordSize:DWORD
       DW_SIZE EQU 4

       mov     DWordSize, DW_SIZE
       invoke  RegCreateKeyEx, HKEY_LOCAL_MACHINE, lpszKeyName, NULL, NULL, 
               REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, addr pKey, addr Temp
       .if eax == ERROR_SUCCESS
         mov     eax, REG_DWORD
         mov     Temp, eax
         invoke  RegQueryValueEx, pKey, lpszValueName, 
                 NULL, ADDR Temp, lpdwValue, ADDR DWordSize 
         invoke  RegCloseKey, pKey
       .endif
       ret
;--------------------------------------
GetRegKeyDW  ENDP


SetRegKeyDW  PROC  lpdwValue    :DWORD,
                   lpszKeyName  :DWORD,
                   lpszValueName:DWORD
;--------------------------------------
       LOCAL Disp:DWORD
       LOCAL pKey:DWORD
       DW_SIZE EQU 4

       invoke  RegCreateKeyEx, HKEY_LOCAL_MACHINE, lpszKeyName, NULL, NULL, 
               REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, addr pKey, addr Disp
       .if eax == ERROR_SUCCESS
         invoke  RegSetValueEx, pKey, lpszValueName, 
                 NULL, REG_DWORD_LITTLE_ENDIAN, lpdwValue, DW_SIZE 
         invoke  RegCloseKey, pKey
       .endif
       ret
;--------------------------------------
SetRegKeyDW  ENDP


GtFrmRegistry  PROC
;--------------------------------------
       invoke  GetRegKeysz, addr szFontName, addr szKeyName, addr szFontMessage, addr FNBufferLength
       invoke  lstrcpy, addr FontName, addr szFontName
       invoke  GetRegKeyDW, ADDR bgColor, ADDR szKeyName, ADDR szBGCMessage
       m2m     cc.rgbResult, bgColor   ; Store current BGColor in the Choosecolor structure
       invoke  GetRegKeyDW, ADDR szPointSize, ADDR szKeyName, ADDR szPointMessage
       invoke  GetRegKeyDW, ADDR szTwipsSize, ADDR szKeyName, ADDR szTwipsMessage
       mov     eax, szPointSize
       .if eax == 0
         mov     eax, defPointSize
         mov     szTwipsSize, eax
         shl     eax, 1
         mov     szPointSize, eax
         invoke  lstrcpy, ADDR FontName, ADDR defFontName
         mov     charF.yHeight, eax
         invoke  lstrcpy, ADDR lf.lfFaceName, ADDR FontName
         invoke  lstrcpy, ADDR charF.szFaceName, ADDR FontName
         invoke  Font                  ; One of two silent passes
       .endif
       mov     eax, szPointSize        ; Get point size times 10
       mov     charF.yHeight, eax      ; Store them in the structure
       invoke  lstrcpy, ADDR lf.lfFaceName, ADDR FontName
       invoke  lstrcpy, ADDR charF.szFaceName, ADDR FontName
       invoke  Font                    ; Two of two silent passes
       mov     byte ptr FirstTime, 0   ; Reset the 'silent run' flag
       invoke  LoadMRUFiles
       ret
;--------------------------------------
GtFrmRegistry  ENDP


;--------------------------------------;
; Display messages in the statusbar.   ;
; Our target is the fourth quadrant    ;
; The message will change every minute ;
;--------------------------------------;
QFour  PROC
;--------------------------------------;
       cmp     hStatus, 0              ; Valid statusbar?
       jz      done                    ; No, then exit
       push    offset sTime            ; Get the local
       call    GetLocalTime            ; time from Windows
       .if Counter == 0                ; Initial run?
         MOVmw   Minute, sTime.wMinute ; Save the current minute
         invoke  SendMessage, hStatus, SB_SETTEXT, 3, addr ShowFontName
         inc     Counter               ; Sync the counter
         ret
       .endif
       push    Minute                  ; Put current minute on the stack
       pop     eax                     ; Get current minute
       cmp     ax, sTime.wMinute       ; Has it changed?
       je      done                    ; Show message for 1 minute
       MOVmw   Minute, sTime.wMinute   ; Update the current minute value
       inc     Counter                 ; Move to the next message
       .if Counter == 5                ; End Of Messages?
         mov     byte ptr Counter, 1   ; Rollback to first message, endlessly repeating
       .endif
       .if Counter == 1                ; Show appropriate message
         invoke  SendMessage, hStatus, SB_SETTEXT, 3, addr ShowFontName
       .elseif Counter == 2            ; Show appropriate message
         invoke  SendMessage, hStatus, SB_SETTEXT, 3, addr ShowfSize
       .elseif Counter == 3            ; Show appropriate message
         invoke  SendMessage, hStatus, SB_SETTEXT, 3, addr TypeOfFile
       .elseif Counter == 4            ; Show appropriate message
         invoke  SendMessage, hStatus, SB_SETTEXT, 3, addr emailAddress
       .endif
done:  ret
;--------------------------------------
QFour  ENDP


;--------------------------------------;
; Find / Replace Procedure             ;
;--------------------------------------;
FindReplace  PROC  hdlg:DWORD, wmsg, wparam, lparam
;--------------------------------------;
       .if wmsg == WM_INITDIALOG       ; If message is INITDIALOG then
         mov     eax, hdlg
         mov     hFRDlg, eax           ; Dialog box for Find or Replace
         invoke  GetDlgItem, hdlg, 101 ; Get handle of edit box
         push    eax                   ; Save handle of edit1
         invoke  SetFocus, eax         ; Set focus to this field
         pop     eax
         invoke  SendMessage, eax, EM_LIMITTEXT, 128, 0
         invoke  GetDlgItem, hdlg, 102
         invoke  SendMessage, eax, EM_LIMITTEXT, 128, 0
         invoke  lstrlen, addr szFind
         .if eax == 1 && szFind == ' '
            mov     szFind, 0
         .endif
         invoke  SetDlgItemText, hdlg, 101, addr szFind
         invoke  SetDlgItemText, hdlg, 102, addr szRep
         invoke  GetDlgItem, hdlg, 302 ; Get search down check
         invoke  SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0 ; Sets find down to checked
         invoke  SendMessage, hRichEd, EM_EXGETSEL, 0, addr ft.chrgText
         jmp     FRDone
       .elseif wmsg == WM_COMMAND
         .if wparam == 401 || wparam == 402 || wparam == 403   ; Find - Replace - ReplaceAll
           jmp     FRText
         .elseif wparam == IDCANCEL
           jmp     CloseIt
         .endif
       .endif
       jmp     FRDone
FRText:
       and     FRFlags, 0
       invoke  SendMessage, hRichEd, EM_EXGETSEL, 0, addr ft.chrgText
       invoke  GetDlgItemText, hdlg, 101, addr szFind, 128
       push    ft.chrgText.cpMin
       pop     ft.chrg.cpMin
       mov     ft.chrg.cpMax, -1
       lea     eax, offset szFind
       mov     ft.lpstrText, eax
       .if wparam != 401               ; Find button
         invoke   GetDlgItemText, hdlg, 102, addr szRep, 128
       .endif
       invoke  IsDlgButtonChecked, hdlg, 201
       .if eax
         or      FRFlags, FR_WHOLEWORD
       .endif
       invoke  IsDlgButtonChecked, hdlg, 202
       .if eax
         or      FRFlags, FR_MATCHCASE
       .endif
       invoke  IsDlgButtonChecked, hdlg, 301
       .if eax
         mov     Prev, 1
         mov     ft.chrg.cpMax, 0
       .endif
       invoke  IsDlgButtonChecked, hdlg, 302
       .if eax
         mov     Prev, 0
         or      FRFlags, FR_DOWN
       .endif
       .if wparam == 401               ; Find button
         invoke  Find, hWnd, 0, FRFlags, ft.lpstrText, Prev
       .endif
Again: .if wparam != 401               ; If not the Find button
         invoke  SendMessage, hRichEd, EM_GETSELTEXT, 0, addr szFindNext
         invoke  lstrcmp, addr szFind, addr szFindNext
         cmp     eax, 0                ; Still a valid highlight?
         jne     FRDone                ; Jump if it has changed
         invoke  SendMessage, hRichEd, EM_REPLACESEL, TRUE, addr szRep
         mov     eax, ft.chrgText.cpMin
         mov     ft.chrgText.cpMax, eax
         invoke  lstrlen, addr szRep
         add     ft.chrgText.cpMax, eax
         invoke  SendMessage, hRichEd, EM_EXSETSEL, 0, addr ft.chrgText
         .if Prev
           sub     ft.chrg.cpMin, 1
         .else
           add     ft.chrg.cpMin, 1
         .endif
         invoke  Find, hWnd, 0, FRFlags, ft.lpstrText, Prev
         .if eax != 1
           jmp     FRDone
         .endif 
         .if wparam == 403             ; If 'Replace All'
           jmp     Again
         .endif
       .endif
       jmp     FRDone
CloseIt:
       invoke  EndDialog, hdlg, wparam ; End the dialog with wparam as return
       mov     eax, TRUE               ; Return
       and     hFRDlg, 0               ; Clear dialog box for Find or Replace
       jmp     FRRet                   ; with TRUE
FRDone:
       mov     eax, FALSE              ; Return with FALSE
FRRet:
       ret                             ; Return
;--------------------------------------;
FindReplace  ENDP


;--------------------------------------;
; FindProc returns TRUE or FALSE       ;
; based on finding FText               ;
;--------------------------------------;
Find  PROC  hwnd:DWORD, Next, Flags, FText, Up
;--------------------------------------
Loop1: invoke  SendMessage, hRichEd, EM_FINDTEXTEX, FRFlags, offset ft
       cmp     eax, -1                 ; Nothing found?
       jne     FoundIt
       .if Up == 0
         invoke  lstrcpyn, offset TopBot, offset Top, 6
       .else
         invoke  lstrcpyn, offset TopBot, offset Bot, 6
       .endif
       invoke  MessageBox, NULL, offset FindEnd, offset szFR, MB_YESNO or\
               MB_ICONQUESTION or MB_TASKMODAL
       cmp     eax, IDNO
       je      Find0
       .if Up == 0
         invoke  SendMessage, hRichEd, EM_SETSEL, 0, 0
         mov     ft.chrg.cpMin, 0
         mov     ft.chrg.cpMax, -1
       .else
         invoke  SendMessage, hRichEd, WM_GETTEXTLENGTH, 0, 0
         mov     ft.chrg.cpMin, eax
         mov     ft.chrg.cpMax, 0
       .endif
       jmp     Loop1
FoundIt:
       .if eax == ft.chrg.cpMin && eax != ft.chrg.cpMax && Up == 0
         inc     ft.chrg.cpMin
         jmp     Loop1
       .endif
       invoke  SendMessage, hRichEd, EM_EXSETSEL, 0, addr ft.chrgText
       mov     eax, TRUE
       ret
Find0:
       mov     eax, FALSE
       ret
;---------------------------------------
Find  ENDP


SetBGColor  PROC
;--------------------------------------;
       .if BGCFlag == 0                ; 0 = Display, 1 = change and display
         .if bgColor == 0              ; Weak here.  Basically traps for no registry entry
           ret
         .else
           invoke  SendMessage, hRichEd, EM_SETBKGNDCOLOR, 0, bgColor
           ret
         .endif
       .else
         mov     BGCFlag, 0            ; Clear the 'Show Dialog' flag
         mov     cc.lStructSize, SIZEOF cc
         push    hWnd                  ; Building the structure
         pop     cc.hwndOwner          ; Store the window owner
         push    hInstance             ; Get the handle
         pop     cc.hInstance          ; Store it in the structure
         mov     cc.lpCustColors, offset CustClrs
         mov     cc.Flags, CC_FULLOPEN or CC_RGBINIT          
         invoke  ChooseColor, ADDR cc  ; Structure built, now show the dialog
         .if eax == 0                  ; Was the Cancel button pressed?
           ret                         ; Leave if it was, cancel is cancel
         .else
           m2m    bgColor, cc.rgbResult
           invoke  SendMessage, hRichEd, EM_SETBKGNDCOLOR, 0, bgColor
           invoke  SetRegKeyDW, addr bgColor, addr szKeyName, addr szBGCMessage
         .endif
         ret                           ; Return to caller
       .endif
       ret                             ; Return to caller
;--------------------------------------;
SetBGColor  ENDP


;--------------------------------------;
; Mange the MRU list in the File Menu  ;
;--------------------------------------;
AppendToMenu  proc
;--------------------------------------;
       invoke  GetMenu, hWnd           ; Get handle to main menu
       mov     hMenu, eax              ; Save the menu handle
       invoke  GetSubMenu, hMenu, 0    ; Get handle to 1st popup menu
       mov     hSubMenu, eax           ; Save the submenu handle
       invoke  GetMenuItemCount, hSubMenu
       sub     eax, 1                  ; Point above the Exit selection
       mov     itemcount, eax          ; Save the index counter
       inc     Partial                 ; Count the separator
       .if Partial > 6                 ; Is the menu full?
         mov     Partial, 6            ; Maximum allowed
       .endif                          ;
       .if isModified == 1             ; If not the first run
         mov     eax, Partial          ; How many unused entries?
         sub     itemcount, eax        ; Fix the index counter
         .while  Partial > 0           ; If not all removed
           invoke  DeleteMenu, hSubMenu, itemcount, MF_BYPOSITION
           dec     Partial             ; Count this removal
         .endw                         ; Do it 6 times at most
       .endif                          ;
       mov     isModified, 1           ; Mark for next run
       cmp     szFileName[0], 0        ; Did we 'load' or 'save as' a file?
       je      empty                   ; Jump if we did not
;      Checking for possible duplication
;      --------------------------------;
       mov     amtAdded, 5             ; Maximum entries in menu
       mov     Block, 0                ; Point to first entry
       .while amtAdded > 0             ; Until all entries are compared
         mov     esi, offset szFileName
         mov     edi, offset MRUDump   ; Get the Menu buffer pointer
         add     edi, Block            ; At this offset
Matches: mov     al, [esi]             ; Get a character
         cmp     [edi], al             ; Match?
         jne     NoMatch               ; Jump to next comparison if no
         inc     edi                   ; Update the buffer pointer
         inc     esi                   ; Update the buffer pointer
         cmp     al, 0                 ; ASCIIZ?
         je      CpyDwn                ; If yes, we found a match
         jmp     Matches               ; Continue parsing
NoMatch: add     Block, 256            ; Move to next menu selection
         dec     amtAdded              ; Count the last comparison
       .endw                           ; Do it 5 times
       mov     Block, 1024             ; Offset into the buffer
CpyDwn:
       cmp     Block, 0
       je      empty
       mov     edi, offset MRUDump     ; Point to the buffer
       add     edi, Block              ; At this offset
       mov     esi, edi                ; Point to the buffer
       sub     esi, 256                ; At this offset
       mov     amtAdded, 256           ; Maximum entry size
       .while amtAdded > 0             ; If not all transferred
         mov     al, [esi]             ; Get a menu character
         mov     [edi], al             ; Move it to the next line
         inc     esi                   ; Update the buffer pointer
         inc     edi                   ; Update the buffer pointer
         dec     amtAdded              ; Count the transfer
       .endw                           ; Do it 256 times
       sub     Block, 256              ; Update the offset pointer
       cmp     Block, 0                ; All done?
       jne     CpyDwn                  ; Go move next menu item, if not done
       mov     edi, offset MRUDump     ; Point to the first MRU menu location
       mov     esi, offset szFileName  ; Point to the new filename
next1: mov     al, [esi]               ; Get a character
       mov     [edi], al               ; Store it in the menu buffer
       inc     esi                     ; Update the buffer pointer
       inc     edi                     ; Update the buffer pointer
       cmp     al, 0                   ; Done?
       jne     next1                   ; Continue the copy until ASCIIZ is reached
empty: mov     Block, 0                ; Start at the beginning, of course
       mov     Partial, 0              ; Clear the item counter
       mov     eax, 1201               ; values are 1201 - 1205
again: mov     MenuID, eax             ; wParam value
       mov     esi, offset MRUDump     ; Get Menu entry offset in buffer
       add     esi, Block              ; This is the offset to it
       cmp     byte ptr [esi], 0       ; No more Menu Items to add?
       je      SeeYa                   ; Jump if all done
       add     Partial, 1              ; Count this menu item
       mov     edi, offset szMenuEntry ; Get string storage location
copy:  mov     al, [esi]               ; Get a character
       mov     [edi], al               ; Store it in the temporary buffer
       inc     esi                     ; Update the buffer pointer
       inc     edi                     ; Update the buffer pointer
       cmp     al, 0                   ; Done?
       jne     copy                    ; Continue the transfer if not done
       add     Block, 256              ; Update the buffer offset pointer
       invoke  AddLineItem             ; Add the item to the menu
       mov     eax, MenuID             ; wParam value
       add     eax, 1                  ; Update the wParam value
       inc     itemcount               ; Update the menu index counter
       cmp     Block, 1280             ; Done?
       jne     again                   ; Continue until all entries are added
SeeYa: invoke  AddSeparator            ; Store a separator in the menu
       invoke  SaveMRUFiles            ; Update the registry
       ret                             ; Return to caller
;--------------------------------------;
AppendToMenu  endp


;--------------------------------------;
; szMenuEntry = points to menu entry   ;
;               filename text string   ;
;      MenuID = wParam menu selection  ;
;   itemcount = menu sel. location     ;
;--------------------------------------;
AddLineItem  proc
;--------------------------------------
       LOCAL   miInfo:MENUITEMINFO

       mov     miInfo.cbSize, sizeof MENUITEMINFO
       mov     miInfo.fMask, MIIM_TYPE or MIIM_ID
       mov     miInfo.fType, MFT_STRING
       invoke  lstrlen, addr szMenuEntry
       mov     miInfo.cch, eax         ; Length of MENUITEM label
       mov     eax, offset szMenuEntry ; Point to the MENUITEM label
       mov     miInfo.dwTypeData, eax  ; Store it in the structure
       mov     miInfo.fState, MFS_ENABLED
       mov     eax, MenuID             ; Get Menu item ID
       mov     miInfo.wID, eax         ; Store the value to be sent to wParam
       mov     miInfo.hSubMenu, NULL   ; This is a MENUITEM
       mov     miInfo.hbmpChecked, NULL
       mov     miInfo.hbmpUnchecked, NULL
       mov     miInfo.dwItemData, eax  ; Again with the ID
       invoke  InsertMenuItem, hSubMenu, itemcount, TRUE, ADDR miInfo
       invoke  EnableMenuItem, hSubMenu, itemcount, MF_BYCOMMAND or MF_ENABLED
       ret                             ; Return to caller
;--------------------------------------;
AddLineItem  endp


;--------------------------------------;
; Append a separator to bottom of menu ;
; just above the Exit selection.       ;
; itemcount contains the value of the  ;
; location on entry into this routine. ;
;--------------------------------------;
AddSeparator  proc
;--------------------------------------
       LOCAL   miInfo:MENUITEMINFO

       mov     miInfo.cbSize, sizeof MENUITEMINFO
       mov     miInfo.fState, 0
       mov     miInfo.hSubMenu, 0
       mov     miInfo.hbmpChecked, 0
       mov     miInfo.hbmpUnchecked, 0
       mov     miInfo.dwItemData, 0
       mov     miInfo.fType, MFT_SEPARATOR
       mov     miInfo.dwTypeData, 0
       mov     miInfo.cch, 0
       mov     miInfo.wID, 0
       mov     miInfo.fMask, MIIM_TYPE
       invoke  InsertMenuItem, hSubMenu, itemcount, 1, ADDR miInfo
       ret                             ; Return to caller
;--------------------------------------;
AddSeparator  endp


;--------------------------------------;
; NOTE:  At the first blank entry, the ;
; search will end.  If you delete the  ;
; first item, this routine will report ;
; that there are NO MRU files, EVEN IF ;
; the next 4 entries all have values.  ;
; Those entries will just disappear.   ;
;--------------------------------------;
LoadMRUFiles  proc
;--------------------------------------
       invoke  GetRegKeysz, addr szMRU_File1, addr szKeyName, addr szMRUMessage1, addr MRUBufLen1
       invoke  GetRegKeysz, addr szMRU_File2, addr szKeyName, addr szMRUMessage2, addr MRUBufLen2
       invoke  GetRegKeysz, addr szMRU_File3, addr szKeyName, addr szMRUMessage3, addr MRUBufLen3
       invoke  GetRegKeysz, addr szMRU_File4, addr szKeyName, addr szMRUMessage4, addr MRUBufLen4
       invoke  GetRegKeysz, addr szMRU_File5, addr szKeyName, addr szMRUMessage5, addr MRUBufLen5
       mov     esi, offset szMRU_File1 ; Point to the first menu item
       mov     amtAdded, 0             ; Clear the line buffer counter
       mov     eax, 5                  ; Five possible items
       .while eax > 0                  ; Until all are tested
         cmp     byte ptr [esi], 0     ; Is the item empty?
         je      done                  ; Look no further if it is
         add     amtAdded, 256         ; increase the transfer size
         add     esi, 256              ; Move to the next entry
         dec     eax                   ; Count this comparison
       .endw                           ; Do it 5 times
done:  mov     edi, offset MRUDump     ; Point to the Menu buffer
       mov     esi, offset szMRU_File1 ; Point to the Registry buffer
       .while amtAdded > 0             ; Until all bytes are transferred
         mov     al, [esi]             ; Get a byte from the Registry buffer
         mov     [edi], al             ; Store it in the Menu buffer
         inc     esi                   ; Update the buffer pointer
         inc     edi                   ; Update the buffer pointer
         dec     amtAdded              ; Count the byte
       .endw                           ;
       mov     esi, offset EndOfDump   ; End of buffer pointer
again: cmp     esi, edi                ; all erased?
       je      bye                     ; Jump if done
       mov     byte ptr [edi], 0       ; Clear a character
       inc     edi                     ; Update the buffer pointer
       jmp     again                   ; Continue clearing unused portion of buffer
bye:   ret                             ; Return to caller
;--------------------------------------;
LoadMRUFiles  endp


SaveMRUFiles  proc
;--------------------------------------;
       mov     amtAdded, 1280          ; Menu buffer size
       mov     esi, offset MRUDump     ; Point to the Menu buffer
       mov     edi, offset szMRU_File1 ; Point to the Registry buffer
       .while amtAdded > 0             ; Until all bytes are transferred
         mov     al, [esi]             ; Get a character from the Menu buffer
         mov     [edi], al             ; Store it in the Registry buffer
         inc     esi                   ; Update the buffer pointer
         inc     edi                   ; Update the buffer pointer
         dec     amtAdded              ; Count the byte transfer
       .endw                           ;
       invoke  SetRegKeysz, addr szMRU_File1, addr szKeyName, addr szMRUMessage1, sizeof szMRUMessage1
       invoke  SetRegKeysz, addr szMRU_File2, addr szKeyName, addr szMRUMessage2, sizeof szMRUMessage2
       invoke  SetRegKeysz, addr szMRU_File3, addr szKeyName, addr szMRUMessage3, sizeof szMRUMessage3
       invoke  SetRegKeysz, addr szMRU_File4, addr szKeyName, addr szMRUMessage4, sizeof szMRUMessage4
       invoke  SetRegKeysz, addr szMRU_File5, addr szKeyName, addr szMRUMessage5, sizeof szMRUMessage5
       ret                             ; Return to caller
;--------------------------------------;
SaveMRUFiles  endp


SpecialProc  PROC  hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       .if uMsg == WM_INITDIALOG
         invoke  SetDlgItemText, hWin, 2007, addr szButton3
         ret
       .elseif uMsg == WM_CLOSE
         invoke  EndDialog, hWin, 0
         push    1
         pop     eax
         ret
       .elseif uMsg == WM_COMMAND
         .if wParam == IDC_ASSEMBLER
           invoke  SetDlgItemText, hWin, 2007, addr szButton1
           ret
         .elseif wParam == IDC_JCOMPILER
           invoke  SetDlgItemText, hWin, 2007, addr szButton2
           ret
         .elseif wParam == IDC_GENERAL
           invoke  SetDlgItemText, hWin, 2007, addr szButton3
           ret
         .elseif wParam == IDC_REPORT
           invoke  SetDlgItemText, hWin, 2007, addr szButton4
           ret
         .elseif wParam == IDC_NOTES
           invoke  SetDlgItemText, hWin, 2007, addr szButton5
           ret
         .elseif wParam == IDC_ABOUT
           invoke  SetDlgItemText, hWin, 2007, addr szButton6
           ret
         .elseif wParam == IDCANCEL
           invoke  EndDialog, hWin, 0
           push    1
           pop     eax
         ret
         .endif
       .endif
       xor     eax, eax
       ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
SpecialProc  endp

       end     program
